unit IPlotLoader;
{$I utils.inc}{ Copyright (C) 2005 C M Western; see AdvOpt.pas for license}
interface

uses Classes, ExpPlotLoader, MathSup;

type

  { TInteractivePlotLoaderConnector }

  TInteractivePlotLoaderConnector = class(TExperimentalPlotLoaderConnector)
  public
    constructor Create(AnObject: TObject; AStreamName: string); override;
    procedure ReportError(Msg: string; Fatal: Boolean); override;
    function QueryPickDest(var AChannelDest: TIntegerArray; var AnWeights: Integer; Limits: TDPointArray): Integer; override;
  end;

implementation

uses {$IFDEF LCL_} LCLType, {$ENDIF}
     {$IFDEF MSWINDOWS} Windows, {$ENDIF}
     Forms, PickDest, SysUtils;

{ TIneractivePlotLoaderConnector }

function TInteractivePlotLoaderConnector.QueryPickDest(
  var AChannelDest: TIntegerArray; var AnWeights: Integer; Limits: TDPointArray): Integer;
begin
  if not Assigned(PickDestForm) then
    Application.CreateForm(TPickDestForm,PickDestForm);
  Result := PickDestForm.Execute(AChannelDest, AnWeights, Limits, StreamName, ExperimentalPlotLoader.ColumnNames);
end;

constructor TInteractivePlotLoaderConnector.Create(AnObject: TObject; AStreamName: string);
begin
  inherited Create(AnObject, AStreamName);
  LoadAll := False;
end;

procedure TInteractivePlotLoaderConnector.ReportError(Msg: string; Fatal: Boolean);
begin
  if Fatal then
    raise Exception.Create(Msg)
  else if FReportErrors then
    case Application.MessageBox(PChar(Msg + '. Report further errors?'), 'Error', MB_YESNOCANCEL) of
      IDCANCEL: Abort;
      IDNO: FReportErrors := False;
    end;
end;

end.

