unit LineExportOpt;
{$I utils.inc}
interface

uses
  {$IFDEF MSWINDOWS} Windows, Messages,  {$ENDIF}
  SysUtils, Variants, Classes, Graphics, Controls, Forms, Buttons,
  Dialogs, StdCtrls, AlEdit, EditExtr, NewSpin, MNode, Mixture;

type
  TLineExportOptions = class(TForm)
    FitFormatCheck: TCheckBox;
    ThresholdSpin: TFixedSpin;
    Label1: TLabel;
    OKButton: TButton;
    CancelButton: TButton;
    Label2: TLabel;
    FileFormat: TComboBox;
    procedure ThresholdSpinIncrement(Sender: TObject; var NewValue: Double;
      LastValue: Double; n: Integer);
  public
    procedure SetDefaultType(AFileName: string);
    function PrintLevel: TPrintLevel;
  end;

var
  LineExportOptions: TLineExportOptions;

implementation

{$IFNDEF FPC}
{$R *.dfm}
{$ELSE}
{$R *.lfm}
{$ENDIF}

function TLineExportOptions.PrintLevel: TPrintLevel;
begin
  case FileFormat.ItemIndex of
    1: Result := plText;
    2: Result := plCSV;
    3: Result := plBinary;
  else
    Result := plLineList;
  end;
end;

procedure TLineExportOptions.SetDefaultType(AFileName: string);
var
  Ext: string;
begin
  Ext := LowerCase(ExtractFileExt(AFileName));
  if Ext = '.csv' then
    FileFormat.ItemIndex := 2
  else if Ext = '.txt' then
    FileFormat.ItemIndex := 1
  else if Ext = '.bin' then
    FileFormat.ItemIndex := 3
  else
    FileFormat.ItemIndex := 0
end;

procedure TLineExportOptions.ThresholdSpinIncrement(Sender: TObject;
  var NewValue: Double; LastValue: Double; n: Integer);
begin
  if LastValue <= 0 then
    LastValue := 1e-6;
  if n < 0 then
    NewValue := LastValue / 10
  else
    NewValue := LastValue * 10;
end;

end.
