unit OvrlyFrm;
{$I utils.inc}{Copyright (C) 2005 C M Western; see commandline.pas for license}
interface

uses
  {$IFDEF MSWINDOWS} Windows, {$ENDIF}
  Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ConstFrm, Menus, ComCtrls, Grids, NGrid, StdCtrls, Buttons,
  ExtCtrls, Split, Overlay, GridEx, MNode, Mixture, ExtDlgs, ScrlCtrl,
  Graphs, GraphRange, GraphI, GraphM, ExpPlot, LogControl, EditLog;

type

  { TOverlayForm }

  TOverlayForm = class(TConstantsForm)
    OpenButton: TSpeedButton;
    SaveButton: TSpeedButton;
    SaveAsButton: TSpeedButton;
    SaveDialog: TSaveDialog;
    OpenDialog: TOpenDialog;
    InvertItem: TMenuItem;
    DetailsPanel: TPanel;
    SplitV: TSplit;
    BitmapPanel: TPanel;
    BitmapToolbar: TPanel;
    CancelButton: TButton;
    OneToOneButton: TSpeedButton;
    Label2: TLabel;
    Xpixel1Button: TButton;
    Xpixel2Button: TButton;
    BaselineButton: TButton;
    MaximumButton: TButton;
    ScrollBox: TScrollBox;
    PasteOverlayButton: TSpeedButton;
    CopyButton: TSpeedButton;
    ExportCurrentButton: TSpeedButton;
    AddOpenButton: TSpeedButton;
    OpenPictureDialog: TOpenPictureDialog;
    SavePictureDialog: TSavePictureDialog;
    PlotPanel: TPanel;
    PlotToolbar: TPanel;
    ExportCurrentButton2: TSpeedButton;
    AddOpenButton2: TSpeedButton;
    GraphD: TGraphD;
    ClearPlotPeaksButton: TButton;
    PaintBox: TPaintBox;
    CopyPeaksButton: TButton;
    ZoomButton: TSpeedButton;
    ZoomOutButton: TSpeedButton;
    ResetZoomButton: TSpeedButton;
    OperatePopupMenu: TPopupMenu;
    OperateButton: TButton;
    CompactItem: TMenuItem;
    ClearPeaksItem: TMenuItem;
    CropItem: TMenuItem;
    PlateItem: TMenuItem;
    UndoItem: TMenuItem;
    PlateAngleItem: TMenuItem;
    TopLeftButton: TSpeedButton;
    TopRightButton: TSpeedButton;
    BottomLeftButton: TSpeedButton;
    BottomRightButton: TSpeedButton;
    AllCornersButton: TSpeedButton;
    PlotOperateButton: TButton;
    PlotPopupMenu: TPopupMenu;
    CropPlotItem: TMenuItem;
    DiscardFrequencyItem: TMenuItem;
    SeparateItem: TMenuItem;
    SmoothItem: TMenuItem;
    CompressItem: TMenuItem;
    JoinToItem: TMenuItem;
    OtherInvertItem: TMenuItem;
    JoinAllItem: TMenuItem;
    FindZeroItem: TMenuItem;
    ScaledItem: TMenuItem;
    UnscaledItem: TMenuItem;
    HideOthersItem: TMenuItem;
    HideItem: TMenuItem;
    ShowAllItem: TMenuItem;
    SwapxandyItem: TMenuItem;
    DiscardIntensityItem: TMenuItem;
    CompressAllItem: TMenuItem;
    procedure PlotOperateButtonClick(Sender: TObject);
    procedure DiscardFrequencyItemClick(Sender: TObject);
    procedure ScaleItemClick(Sender: TObject);
    procedure SeparateButtonClick(Sender: TObject);
    procedure AllCornersButtonClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure PlateAngleItemClick(Sender: TObject);
    procedure OperateButtonClick(Sender: TObject);
    procedure ResetZoomButtonClick(Sender: TObject);
    procedure ZoomOutButtonClick(Sender: TObject);
    procedure ZoomButtonClick(Sender: TObject);
    procedure CopyPeaksButtonClick(Sender: TObject);
    procedure PlateButtonClick(Sender: TObject);
    procedure CropButtonClick(Sender: TObject);
    procedure UndoButtonClick(Sender: TObject);
    procedure PaintBoxMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PaintBoxPaint(Sender: TObject);
    procedure ClearPlotPeaksButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure GraphDMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure ExportCurrentButtonClick(Sender: TObject);
    procedure AddOpenButtonClick(Sender: TObject);
    procedure PasteOverlayButtonClick(Sender: TObject);
    procedure CopyButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure PaintBoxMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure MaximumButtonClick(Sender: TObject);
    procedure OptGridDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
    procedure CompactButtonClick(Sender: TObject);
    procedure OneToOneButtonClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure SaveAsButtonClick(Sender: TObject);
    procedure OpenButtonClick(Sender: TObject);
    procedure InvertItemClick(Sender: TObject);
    procedure SmoothItemClick(Sender: TObject);
    procedure CompressItemClick(Sender: TObject);
    procedure JoinToItemClick(Sender: TObject);
    procedure JoinAllItemClick(Sender: TObject);
    procedure FindZeroItemClick(Sender: TObject);
    procedure HideOthersItemClick(Sender: TObject);
    procedure ShowAllItemClick(Sender: TObject);
    procedure HideItemClick(Sender: TObject);
    procedure TreePopupMenuPopup(Sender: TObject);
    procedure SwapxandyItemClick(Sender: TObject);
    procedure DiscardIntensityItemClick(Sender: TObject);
    procedure SplitVMoved(Sender: TObject);
    procedure CompressAllItemClick(Sender: TObject);
  private
    FMouseSetting: Integer;
    TopLeftXIndex: Integer;
    Selecting: Boolean; { Mouse is selecting an area }
    FAreaSelected: Boolean;
    FSelectedArea:TRect;
    ZoomPicture: Boolean;
    AllCorners: Boolean;
    nAverage: Integer;
    xAxisInterval: Double;
    DummySimulation: TSimulation;
    PlotRanges: TPlotRanges;
    FPlotLockout: Integer;
    FPlotNeeded: Boolean;
    function Point(i:Integer; out APoint: TPoint; DeScale: Boolean):Boolean;
    function Overlays: TOverlays;
    procedure SetMouseSetting(const Value: Integer);
    procedure ScaleCoords(var X, Y: Integer);
    procedure DeScaleCoords(var X, Y: Integer; InvertY: Boolean);
    function ScaleRect(Rect:TRect; InvertY:Boolean):TRect;
    {$IFDEF VCL_}
    procedure WMDropFiles(var Message: TMessage); message WM_DROPFILES;
    {$ENDIF}
    procedure CancelSelection;
    procedure DrawSelectedArea;
    procedure UpdateSelection(X, Y: Integer; NewPoint:Boolean);
  protected
    procedure MNodeChange(Sender: TMnode; Change: TMNodeChange; Index: Integer); override;
    procedure FormDropFiles(Sender: TObject; const FileNames: array of String);
    function MoveUpDown(Shift: Integer; Test: Boolean):Boolean; override;
    procedure UpdateActions; override;
  public
    constructor Create(AOwner: TCOmponent); override;
    procedure AddOverlayFile(FileName: string);
    function BaseNodeClass: TClass; override;
    destructor Destroy; override;
    function DefaultCaption: string; override;
    procedure ShowItem(MNode: TMNode); override;
    procedure SettingChanged(MNode: TMNode; Index: Integer); override;
    procedure AdjustSplitters; override;
    property MouseSetting: Integer read FMouseSetting write SetMouseSetting;
    procedure UpdateAlwaysVisible(Force: Boolean); override;
    procedure ZoomTo(Rect: TRect; ScreenCords: Boolean);
    procedure SetZoom(Zoom:Double);
    procedure ShowCurrentPlot;
    function CompressPlot(Plot: TExperimentalPlot; ShowDialog: Boolean): Boolean;
  end;

var
  OverlayForm: TOverlayForm;

implementation

uses {$IFDEF LCL_} LCLType, {$ENDIF}
     {$IFNDEF CONSOLE} ClipBrd, {$ENDIF}
     UCompat, Global, Huge, MathSup, ExpBitmap, ChildForm, Worker,
     Math, Plate, WCompat, LogUnit, ExpPlotLoader, CalSource, Units, SmoothDlg,
     Main, ApplyFrm, CompressDlg, Constrain, MNodeExpr, LoomisWood;

{$IFNDEF FPC}
{$R *.dfm}
{$ELSE}
{$R *.lfm}
{$ENDIF}

function TOverlayForm.Overlays: TOverlays;
begin
  Result := BaseNode as TOverlays;
end;

destructor TOverlayForm.Destroy;
begin
  if Self = OverlayForm then
    OverlayForm := nil;
  FreeAndNil(DummySimulation);
  inherited Destroy;
end;

procedure TOverlayForm.DiscardFrequencyItemClick(Sender: TObject);
begin
  if CurrentMNode is TExperimentalPlot then
    TExperimentalPlot(CurrentMNode).DiscardFrequency;
end;

var
  ScaleText: string = '1000';

procedure TOverlayForm.ScaleItemClick(Sender: TObject);
var
  Factor: Double;
begin
  if (CurrentMNode is TExperimentalPlot) and not CalculationInProgress and InputQuery('Scale Spectrum', 'Vertical Scale Factor', ScaleText) then
    if TryStrToFloat(ScaleText, Factor) then
      TExperimentalPlot(CurrentMNode).VerticalScale(Factor)
    else
      raise EReportException.Create('Bad number:'+ScaleText);
end;

procedure TOverlayForm.DiscardIntensityItemClick(Sender: TObject);
begin
  if CurrentMNode is TExperimentalPlot then
    TExperimentalPlot(CurrentMNode).DiscardIntensity;
end;

procedure TOverlayForm.SaveButtonClick(Sender: TObject);
var
  Ovr: TOverlays;
begin
  if Sender is TOverlays then
    Ovr := TOverlays(Sender)
  else
    Ovr := Overlays;
  if Ovr <> nil then
    with Ovr do begin
      if (Name = '') or (Name = 'Overlays') then
        SaveAsButtonClick(Ovr)
      else
        SaveToFile(DirectoryName+Name);
    end;
end;

procedure TOverlayForm.SaveAsButtonClick(Sender: TObject);
var
  Ovr: TOverlays;
begin
  SaveDialog.DefaultExt := 'ovr';
  SaveDialog.FilterIndex := 1;
  if Sender is TOverlays then
    Ovr := TOverlays(Sender)
  else
    Ovr := Overlays;
  if (Ovr <> nil) and SaveDialog.Execute then begin
    if ExtractFileExt(SaveDialog.FileName) = '.pgo' then
      raise EReportException.Create('.pgo files are used to save simulation parameters; please use the Save menu item on the main window for these');
    Ovr.SaveToFile(SaveDialog.FileName);
  end;
  ReStuff;
end;

procedure TOverlayForm.OpenButtonClick(Sender: TObject);
begin
  if OpenDialog.Execute then begin
    LoadGeneralFile(OpenDialog.FileName,False,True,MainForm.Simulation.PlotUnits);
    Mainform.ConsiderReplot(GlobalMixture.nSpecies = 0);
  end;
end;

procedure TOverlayForm.OperateButtonClick(Sender: TObject);
begin
  OperatePopupMenu.PopupComponent := OperateButton;
  OperatePopupMenu.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;

function TOverlayForm.DefaultCaption: string;
begin
  Result := 'Overlays';
end;

function TOverlayForm.BaseNodeClass: TClass;
begin
  Result := TOverlays;
end;

procedure TOverlayForm.InvertItemClick(Sender: TObject);
var
  i: Integer;
  MNode: TMNode;
begin
  for i := 0 to TreeView.SelectionCount - 1 do begin
    MNode := SelectedNode(i);
    if MNode is TPlot then
      TPlot(MNode).Invert;
  end;
  ShowItem(CurrentMNode);
  MainForm.ConsiderReplot;
end;

procedure TOverlayForm.JoinAllItemClick(Sender: TObject);
var
  i: Integer;
  EPlots: array of TExperimentalPlot;
  Mx: Double;
  ScalePlot: Boolean;
  procedure Add(Plot: TExperimentalPlot);
  var
    i: Integer;
    T: TExperimentalPlot;
  begin
    if (Length(EPlots) > 0) and (EPlots[0].Units <> Plot.Units) then
      raise EReportException.Create('Overlays must have same units');
    for i := 0 to High(EPlots) do begin
      if Plot.HMin < EPlots[i].HMin then begin
        T := Plot;
        Plot := EPlots[i];
        EPlots[i] := T;
      end;
      if Plot.HMax < EPlots[i].HMax then
        Exit; { Completely overlapped }
    end;
    SetLength(EPlots, Length(EPlots)+1);
    EPlots[High(EPlots)] := Plot;
  end;
begin
  ScalePlot := (Sender as TComponent).Tag = 1;
  for I := 0 to GlobalOverlays.nPlots-1 do
    if GlobalOverlays[i] is TExperimentalPlot then
      Add(TExperimentalPlot(GlobalOverlays[i]));
  if Length(EPlots) <= 1 then
    raise EReportException.Create('Not enough suitable spectra');
  if Application.MessageBox(PChar('Merge ' + IntToStr(Length(EPlots)) + ' overlays into one spectrum?'),
                           'Confirm', MB_YESNO or MB_ICONQUESTION) = IDNO then
    Exit;
  BeginGlobalUpdate;
  try
    Mx := Eplots[0].HMax;
    for i := 1 to High(EPlots) do begin
      EPlots[0].JoinTo((Mx+Eplots[i].HMin)/2,EPlots[i],ScalePlot, IsEnergyUnit(EPlots[0].Units));
      Mx := EPlots[i].HMax;
      EPlots[i].Free;
    end;
    EPlots[0].CheckProperties;
  finally
    EndGlobalUpdate;
  end;
  MainForm.ConsiderReplot;
end;

procedure TOverlayForm.JoinToItemClick(Sender: TObject);
var
  OtherPlot: TPlot;
  ScalePlot: Boolean;
begin
  ScalePlot := False;
  OtherPlot := PromptForOverlay(Self,'Join To',ScalePlot,'Scale Plot',False,TExperimentalPlot,CurrentMNode) as TPlot;
  if Assigned(OtherPlot) then
    with CurrentMNode as TExperimentalPlot do
      JoinTo((HMax+OtherPlot.HMin)/2,OtherPlot as TExperimentalPlot,ScalePlot,IsEnergyUnit(Units));
end;

var
  Threshold: Double = 50;

procedure TOverlayForm.CompactButtonClick(Sender: TObject);
var
  s: string;
begin
  s := FloatToStr(Threshold);
  if Assigned(CurrentMNode) and InputQuery('Threshold', 'Input Threshold as a %age of the white level', s) then begin
    Threshold := StrToFloat(s);
    with CurrentMNode as TBitmapPlot do
      Compact(Threshold);
  end;
  ShowItem(CurrentMNode);
  MainForm.ConsiderReplot;
end;

procedure TOverlayForm.CompressAllItemClick(Sender: TObject);
var
  i: Integer;
  MNode: TMNode;
  First: Boolean;
begin
  First := True;
  for i := 0 to TreeView.SelectionCount - 1 do begin
    MNode := SelectedNode(i);
    if MNode is TExperimentalPlot then begin
      if CompressPlot(MNode as TExperimentalPlot, First) then
        Break;
      First := False;
    end;
  end;
end;

procedure TOverlayForm.CompressItemClick(Sender: TObject);
begin
  CompressPlot(CurrentMNode as TExperimentalPlot, True);
end;

function TOverlayForm.CompressPlot(Plot: TExperimentalPlot; ShowDialog: Boolean):Boolean;
begin
  Result := True;
  if not Assigned(CompressForm) then
    CompressForm := TCompressForm.Create(Application);
  if ShowDialog then
    with CompressForm do begin
      nPointsSpin.Value := Max(2,Abs(nAverage));
      xIntervalSpin.Value := xAxisInterval;
      if nAverage >0 then
        EquallySpacedRadioButton.Checked := True
      else
        xIntervalRadioButton.Checked := True;
      EquallySpacedRadioButtonClick(nil);
      if ShowModal <> mrOk then
        Exit;
        if EquallySpacedRadioButton.Checked then begin
          nAverage := nPointsSpin.Value;
        end else begin
          nAverage := -Max(2,nPointsSpin.Value);
          xAxisInterval := xIntervalSpin.Value;
        end
    end;
  Result := False;
  if nAverage > 0 then
    Plot.Compress(nAverage)
  else
    Plot.ReBin(xAxisInterval);
  if Visible then
    ShowItem(CurrentMNode);
  MainForm.ConsiderReplot;
end;

procedure TOverlayForm.ShowAllItemClick(Sender: TObject);
var
  I: Integer;
begin
  with BaseNode as TOverlays do
    for I := 0 to nPlots - 1 do
      Plots[I].Hide := False;
  MainForm.ConsiderReplot;
end;

procedure TOverlayForm.ShowCurrentPlot;
  procedure ShowExperimentalPlot(Plot: TExperimentalPlot);
  var
    d: Double;
  begin
    with Plot do begin
      if IsLineList then begin
        d := (HMax - HMin)/50;
        GraphD.Map(HMin-d, HMax+d, 0, 1);
      end else
        GraphD.Map(HMin, HMax, 0, 1);
      DummySimulation.Fmin := GraphD.Xmin;
      DummySimulation.Fmax := GraphD.Xmax;
      DummySimulation.PlotUnits := Units;
      DummySimulation.IntensityUnits := IntensityUnits;
      Show(GraphD, DummySimulation, IntensityUnits, PlotRange(GraphD, 0, 1, 0, 1), PlotRanges, True, False, True);
      if Length(PlotRanges) = 1 then
        GraphD.Axis(GraphD.Xmin, GraphD.Xmax, GraphD.Ymin, true, UnitsName);
    end;
  end;
begin
  if (CurrentMNode is TLoomisWood) and (CurrentMNode.Owner is TBitmapPlot) then
    Exit; { Handled elsewhere }
  if not Assigned(DummySimulation) then
    DummySimulation := TSimulation.Create(nil);
  DetailsPanel.Color := clBtnFace; { TODO: Remove when LCL handles colour of overlapping panels correctly }
  SetLength(PlotRanges,0);
  if CurrentMNode is TOverlays then
    Overlays.FixupProperties; { Trigger any changes here, as routine may be re-entered }
  GraphD.Start;
  if (CurrentMNode is TOverlays) or ((CurrentMNode is TLoomisWood) and (CurrentMNode.Owner is TOverlays)) then begin
    if Overlays.HasLimits then begin
      GraphD.Map(Overlays.HMin, Overlays.HMax, -0.03, 1);
      GraphD.Axis(GraphD.Xmin, GraphD.Xmax, GraphD.Ymin, true, Overlays.UnitsName);
      DummySimulation.Fmin := GraphD.Xmin;
      DummySimulation.Fmax := GraphD.Xmax;
      DummySimulation.PlotUnits := Overlays.Units;
      DummySimulation.IntensityUnits := Overlays.IntensityUnits;
      Overlays.Show(GraphD, DummySimulation, Overlays.Units, Overlays.IntensityUnits, PlotRange(GraphD, 0, 1, 0, 1), PlotRanges, True);
    end;
  end else if CurrentMNode is TCalibrationSource then
    with CurrentMNode as TCalibrationSource do begin
      GraphD.Map(HMin, HMax, 0, 1);
      GraphD.Axis(GraphD.Xmin, GraphD.Xmax, GraphD.Ymin, true, NameOfUnit(Units));
      DummySimulation.Fmin := HMin;
      DummySimulation.Fmax := HMax;
      DummySimulation.PlotUnits := Units;
      DummySimulation.IntensityUnits := Arbitrary;
      Show(GraphD, DummySimulation, Arbitrary, PlotRange(GraphD, 0, 1, 0, 1), PlotRanges, True, False);
    end
  else if CurrentMNode is TVariables then
    GraphD.PlotChanged { Skip }
  else if (CurrentMNode is TIntensityCorrection) or (CurrentMNode is TLoomisWood) then
    ShowExperimentalPlot(CurrentMNode.Owner as TExperimentalPlot)
  else if Assigned(CurrentMNode) then
    ShowExperimentalPlot(CurrentMNode as TExperimentalPlot);
  GraphD.Finish;
end;

procedure TOverlayForm.ShowItem(MNode: TMNode);
begin
  BeginGlobalUpdate;
  try
    inherited;
    MouseSetting := -1;
    if (MNode is TLoomisWood) and (MNode.Owner is TBitmapPlot) then
      MNode := MNode.Owner as TBitmapPlot;
    if Assigned(MNode) and (MNode is TBitmapPlot) then
      with MNode as TBitmapPlot do begin
        TopLeftXIndex := IndexOfSetting('TopLeftX');
        TopLeftButton.Tag := TopLeftXIndex;
        TopRightButton.Tag := IndexOfSetting('TopRightX');
        BottomLeftButton.Tag := IndexOfSetting('BottomLeftX');
        BottomRightButton.Tag := IndexOfSetting('BottomRightX');
        Xpixel1Button.Tag := IndexOfSetting('Xpixel1');
        Xpixel2Button.Tag := IndexOfSetting('Xpixel2');
        BaselineButton.Tag := IndexOfSetting('BaselinePixel');
        MaximumButton.Tag := IndexOfSetting('MaximumPixel');
        AllCornersButton.Tag := TopLeftButton.Tag;
        BitmapPanel.Visible := True;
        PlotPanel.Visible := False;
        BitmapPanel.Align := alClient;
        CancelSelection;
        if Assigned(Picture.Graphic) then begin
         { with Image.Picture.Bitmap do begin
            Height := Picture.Graphic.Height;
            Width := Picture.Graphic.Width;
            Canvas.Brush.Color := clWhite;
            Canvas.FillRect(Rect(0,0,Width, Height));
            Canvas.Draw(0,0,Picture.Graphic);
          end }
          CompactItem.Enabled := not ((Picture.Graphic is TBitmap)
                                          and (TBitmap(Picture.Graphic).PixelFormat = pf1bit))
        end else
          CompactItem.Enabled := False;
        ResetZoomButtonClick(nil);
      end
    else begin
      PlotPanel.Visible := True;
      PlotPanel.Align := alClient;
      BitmapPanel.Visible := False;
      FPlotNeeded := True;
    end;
    PlotOperateButton.Visible := CurrentMNode is TExperimentalPlot;
  finally
    EndGlobalUpdate(False);
  end;
end;

procedure TOverlayForm.SmoothItemClick(Sender: TObject);
begin
  with SmoothForm do
    if ShowModal = mrOK then
      (CurrentMNode as TExperimentalPlot).Smooth(WidthSpinBox.Value,DerivativeSpinBox.Value,PolySpinBox.Value);
  ShowItem(CurrentMNode);
  MainForm.ConsiderReplot;
end;

procedure TOverlayForm.SplitVMoved(Sender: TObject);
begin
  AdjustSplitters;
end;

procedure TOverlayForm.TreePopupMenuPopup(Sender: TObject);
begin
  inherited;
  HideItem.Visible := (CurrentMNode is TPlot) or (TreeView.SelectionCount > 1);
  HideItem.Checked := (CurrentMNode is TPlot) and TPlot(CurrentMNode).Hide;
  HideOthersItem.Visible := HideItem.Visible;
  InvertItem.Visible := HideItem.Visible;
  CompressAllItem.Visible := HideItem.Visible;
end;

procedure TOverlayForm.SeparateButtonClick(Sender: TObject);
begin
  BeginGlobalUpdate;
  try
    if CurrentMNode is TExperimentalPlot then
      TExperimentalPlot(CurrentMNode).Separate;
  finally
    EndGlobalUpdate;
  end;
end;

procedure TOverlayForm.SwapxandyItemClick(Sender: TObject);
begin
  if CurrentMNode is TExperimentalPlot then
    TExperimentalPlot(CurrentMNode).SwapXandY;
end;

procedure TOverlayForm.SetMouseSetting(const Value: Integer);
begin
  FMouseSetting := Value;
  OptGrid.Invalidate;
  CancelButton.Enabled := Value > 0;
  if MouseSetting > 0 then begin
    OptGrid.Row := MouseSetting-1;
    OptGrid.Col := 1;
  end else
    AllCorners := False;
  TopLeftButton.Down := MouseSetting = TopLeftButton.Tag;
  TopRightButton.Down := MouseSetting = TopRightButton.Tag;
  BottomLeftButton.Down := MouseSetting = BottomLeftButton.Tag;
  BottomRightButton.Down := MouseSetting = BottomRightButton.Tag;
end;

procedure TOverlayForm.OptGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  if (MouseSetting > 1) and (ACol = 1)
     and ((MouseSetting = ARow+1) or ((MouseSetting = ARow) and (MouseSetting >= TopLeftXIndex)) ) then
    ColouredTextInGrid(OptGrid.Canvas, Rect, 'Click to set', clRed);
end;

procedure TOverlayForm.MaximumButtonClick(Sender: TObject);
begin
  MouseSetting := (Sender as TComponent).Tag;
end;

procedure TOverlayForm.CancelButtonClick(Sender: TObject);
begin
  MouseSetting := -1;
end;

procedure TOverlayForm.CopyButtonClick(Sender: TObject);
var
  AFormat: Word;
  {$IFDEF MSWINDOWS}
  AData: SizeUint;
  APalette: HPALETTE;
  {$ENDIF}
begin
  if Assigned(CurrentMNode) then
    try
      Clipboard.Open;
      if CurrentMNode is TBitmapPlot then begin
        TBitmapPlot(CurrentMNode).Picture.SaveToClipboardFormat(AFormat{$IFDEF VCL_} , AData, APalette {$ENDIF});
        {$IFDEF VCL_}
        if APalette <> 0 then
          Clipboard.SetAsHandle(CF_PALETTE, APalette);
        Clipboard.SetAsHandle(AFormat, AData);
        {$ENDIF}
      end;
      CurrentMNode.CopyToClipboard;
    finally
      Clipboard.Close;
    end;
end;

procedure TOverlayForm.AddOverlayFile(FileName: string);
begin
  AddOverlay(FileName, True, MainForm.Simulation.PlotUnits);
  if GlobalOverlays <> nil then begin
    BaseNode := GlobalOverlays;
    if ActiveObject.Items.Count > 0 then
      ActiveObject.ItemIndex := ActiveObject.Items.Count-1;
  end;
end;

procedure TOverlayForm.AdjustSplitters;
begin
  if SplitV.Top < Height div 3 then
    SelectPanel.Height := Height div 2;
  inherited;
end;

procedure TOverlayForm.AllCornersButtonClick(Sender: TObject);
begin
  MaximumButtonClick(TopLeftButton);
  AllCorners := True
end;

procedure TOverlayForm.PasteOverlayButtonClick(Sender: TObject);
begin
  MainForm.PasteAnotherItemClick(Sender);
end;

procedure TOverlayForm.AddOpenButtonClick(Sender: TObject);
begin
  OpenPictureDialog.Filter :=
    'Data File (*.dat)|*.dat|Overlay File (*.ovr)|*.ovr|'
    +PlotLoaderFilter
//    +GraphicFilter(TGraphic)+'|'
    +'All Files (*.*)|'+AllFilesMask;
  { TODO: hook onselection change to preview other styles of file }
  if OpenPictureDialog.Execute then
    AddOverlayFile(OpenPictureDialog.FileName);
end;

procedure TOverlayForm.FindZeroItemClick(Sender: TObject);
begin
  if CurrentMNode is TExperimentalPlot then
    with CurrentMNode as TExperimentalPlot do begin
      BaseLine := AutoZero;
      CheckProperties;
      ShowItem(CurrentMNode);
      MainForm.ConsiderReplot;
    end;
end;

procedure TOverlayForm.ExportCurrentButtonClick(Sender: TObject);
var
  Stream: TStream;
begin
  if Assigned(CurrentMNode) then
    if CurrentMNode is TBitmapPlot then
      with CurrentMNode as TBitmapPlot do begin
        SavePictureDialog.DefaultExt := GraphicExtension(TGraphicClass(Picture.Graphic.ClassType));
        SavePictureDialog.Filter := GraphicFilter(TGraphicClass(Picture.Graphic.ClassType));
        if SavePictureDialog.Execute then
          Picture.Graphic.SaveToFile(SavePictureDialog.FileName);
      end
    else begin
      SaveDialog.DefaultExt := 'dat';
      SaveDialog.FilterIndex := 2;
      if SaveDialog.Execute then begin
        if ExtractFileExt(SaveDialog.FileName) = '.ovr' then
          (CurrentMNode as TStreamableMNode).SaveToFile(SaveDialog.FileName)
        else begin
          Stream := TFileStream.Create(SaveDialog.FileName, fmCreate);
          try
            CurrentMNode.SimpleSaveToStream(Stream);
          finally
            Stream.Free;
          end;
        end;
      end;
    end;
end;

procedure TOverlayForm.GraphDMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  i, Index: Integer;
  MNode: TMNode;
  Value: Double;
begin
  MNode := CurrentMNode;
  if (CurrentMNode is TOverlays) and (TOverlays(CurrentMNode).nPlots = 1) then
    MNode := CurrentMNode.Items[0];
  i := -1;
  if MNode is TExperimentalPlot then
    with MNode as TExperimentalPlot do begin
      IntensityAt(GraphD.LastMouseX, i);
      if i >= 0 then begin
        StatusBar.Panels[0].Text := 'Data';
        StatusBar.Panels[2].Text := IntToStr(i);
        StatusBar.Panels[4].Text := RoundedStr(Intensity[i], (Imax-Imin)/Height);
        { TODO: Show weights also }
      end;
    end
  else
    StatusBar.Panels[8].Text := RoundedStr(GraphD.LastMouseY, (GraphD.Ymax-GraphD.Ymin)/Height);
  if i < 0 then begin
    StatusBar.Panels[0].Text := '';
    StatusBar.Panels[2].Text := '';
    StatusBar.Panels[4].Text := '';
  end;
  StatusBar.Panels[6].Text := RoundedStr(GraphD.LastMouseX, (GraphD.Xmax-GraphD.Xmin)/Width);
  if Length(PlotRanges) = 1 then begin
    Value := GraphD.LastMouseY;
    Index := FindYRange(Value, GraphD, PlotRanges);
    if Index > -Length(PlotRanges) then
      with PlotRanges[Abs(Index)] do
        StatusBar.Panels[8].Text := RoundedStr(Value, (yx-yi)/((y2-y1)*GraphD.Height))
  end else
    StatusBar.Panels[8].Text := '';
end;

procedure TOverlayForm.HideItemClick(Sender: TObject);
var
  i: Integer;
  MNode: TMNode;
begin
  for i := 0 to TreeView.SelectionCount - 1 do begin
    MNode := SelectedNode(i);
    if MNode is TPlot then
      with TPlot(MNode) do
        Hide := not Hide;
  end;
  MainForm.ConsiderReplot;
end;

procedure TOverlayForm.HideOthersItemClick(Sender: TObject);
var
  I: Integer;
begin
  { Hide everything }
  with BaseNode as TOverlays do
    for I := 0 to nPlots - 1 do
      Plots[I].Hide := True;
  HideItemClick(nil); { And show selected items }
end;

{$IFDEF VCL_}
procedure TOverlayForm.WMDropFiles(var Message: TMessage);
begin
  HandleWMDropFiles(Message, FormDropFiles);
end;
{$ENDIF}

procedure TOverlayForm.FormDropFiles(Sender: TObject; const FileNames: array of String);
var
  i: Integer;
begin
  for i := 0 to High(FileNames) do
    AddOverlayFile(FileNames[i]);
end;

procedure TOverlayForm.FormDestroy(Sender: TObject);
begin
  if HandleAllocated then
    DragAcceptFiles(Self, False);
  inherited;
end;

procedure TOverlayForm.FormResize(Sender: TObject);
  procedure Check(Split: TSplit);
  begin
    Split.Constraints.MinHeight := 5;
    Split.Constraints.MinWidth := 5;
  end;
begin
  inherited;
  if ZoomPicture then
    ResetZoomButtonClick(nil);
  {$IFDEF LCL_}
  { Tweaks to avoid issues with LCL autosizing }
  { TODO: Fix split or LCL }
  Check(SplitV);
  Check(SplitL);
  Check(SplitR);
  DetailsPanel.Constraints.MinHeight := SplitV.MinSize;
  SelectPanel.Constraints.MinHeight := SplitV.MinSize;
  {$ENDIF}
end;

procedure TOverlayForm.FormCreate(Sender: TObject);
begin
  inherited;
  DragAcceptFiles(Self, True);
  {$IFNDEF VCL_}
  OnDropFiles := @FormDropFiles;
  {$ENDIF}
end;

procedure TOverlayForm.UpdateAlwaysVisible(Force: Boolean);
var
  i: Integer;
  SomePeaks: Boolean;
begin
  inherited;
  if (Force or Visible) and Assigned(BaseNode) then begin
    StatusBar.Panels[5].Text := (BaseNode as TUnitsMNode).UnitsTypeName;
    SomePeaks := False;
    if Assigned(CurrentMNode) and not (csDestroying in CurrentMNode.ComponentState) then begin
      if CurrentMNode is TPlot then begin
        SomePeaks := TPlot(CurrentMNode).nPeaks >= 0;
        UndoItem.Enabled := TPlot(CurrentMNode).CanUndo;
      end else if CurrentMNode is TOverlays then
        with TOverlays(CurrentMNode) do
          for i := 0 to nPlots-1 do
            if not (csDestroying in Plots[i].ComponentState) and (Plots[i].nPeaks > 0) then begin
              SomePeaks := True;
              Break;
            end;
    end;
    ClearPlotPeaksButton.Enabled := SomePeaks;
    ClearPeaksItem.Enabled := SomePeaks;
    CropItem.Enabled := FAreaSelected;
  end;
end;

procedure TOverlayForm.SettingChanged(MNode: TMNode; Index: Integer);
begin
  inherited;
  FPlotNeeded := True;
end;

procedure TOverlayForm.ClearPlotPeaksButtonClick(Sender: TObject);
var
  i: Integer;
begin
  if Assigned(CurrentMNode) then
    if CurrentMNode is TPlot then
      TPlot(CurrentMNode).Peaks.Clear
    else if CurrentMNode is TOverlays then
      with CurrentMNode as TOverlays do
        for i := 0 to nPlots - 1 do
          Plots[i].Peaks.Clear;
  ShowItem(CurrentMNode);
end;

procedure TOverlayForm.CancelSelection;
begin
  DrawSelectedArea;
  Selecting := False;
  FAreaSelected := False;
end;

procedure TOverlayForm.DrawSelectedArea;
begin
  if FAreaSelected then
    DrawFocusRectHelper(PaintBox.Canvas, FSelectedArea);
end;

procedure TOverlayForm.UpdateSelection(X, Y: Integer; NewPoint: Boolean);
begin
  DrawSelectedArea;
  if NewPoint and Selecting then begin
    FSelectedArea.Right := X;
    FSelectedArea.Bottom := Y;
    { Make sure rectangle shown includes current cursor point }
    if FSelectedArea.Right > FSelectedArea.Left then
      Inc(FSelectedArea.Right);
    if FSelectedArea.Bottom > FSelectedArea.Top then
      Inc(FSelectedArea.Bottom);
    FAreaSelected := ( abs(FSelectedArea.Right - FSelectedArea.Left) > SmallX )
                    or (abs(FSelectedArea.Bottom - FSelectedArea.Top) > SmallY );
    DrawSelectedArea;
  end;
end;

procedure TOverlayForm.UndoButtonClick(Sender: TObject);
begin
  if not Assigned(CurrentMNode) or not (CurrentMNode is TPlot) then
    Exit;
  with TPlot(CurrentMNode) do
    if CanUndo then
      Undo;
  ShowItem(CurrentMNode);
  MainForm.ConsiderReplot;
end;

constructor TOverlayForm.Create(AOwner: TCOmponent);
begin
  inherited;
  MarginSize := OpenButton.Left;
  nAverage := 2;
  xAxisInterval := 1;
end;

procedure TOverlayForm.CropButtonClick(Sender: TObject);
var
  First, Last, t: Integer;
begin
  if not Assigned(CurrentMNode) then
    Exit;
  if CurrentMNode is TBitmapPlot then begin
    if not FAreaSelected then
      Exit;
    TBitmapPlot(CurrentMNode).Crop(ScaleRect(FSelectedArea,True));
  end else if CurrentMNode is TExperimentalPlot then
    with TExperimentalPlot(CurrentMNode) do begin
      if GraphD.AreaSelected then begin
        IntensityAt(GraphD.SelectedMathArea.Left, First);
        IntensityAt(GraphD.SelectedMathArea.Right, Last);
        if First > Last then begin
          t := First;
          First := Last;
          Last := t;
        end;
      end else begin
        First := FirstPoint;
        Last := LastPoint;
      end;
      Crop(First,Last);
    end;
  ShowItem(CurrentMNode);
end;

procedure TOverlayForm.DeScaleCoords(var X, Y: Integer; InvertY: Boolean);
begin
  with CurrentMNode as TBitmapPlot do begin
    x := Round(x/Picture.Width * PaintBox.ClientWidth);
    if InvertY then
      y := Picture.Height - y;
    y := Round(y/TBitmapPlot(CurrentMNode).Picture.Height * PaintBox.ClientHeight);
  end;
end;

procedure TOverlayForm.PlateAngleItemClick(Sender: TObject);
var
  Positions: TDoubleArray;
  i: Integer;
  Rect: TRect;
  Angle: Double;
  procedure SetPixel(x, y: Integer);
  begin
    DeScaleCoords(x,y,False);
    PaintBox.Canvas.Pixels[x,y] := clAqua;
  end;
begin
  if not Assigned(CurrentMNode) or not (CurrentMNode is TBitmapPlot) then
    Exit;
  if FAreaSelected then
    with TBitmapPlot(CurrentMNode) do begin
      Rect := ScaleRect(FSelectedArea,True);
      Angle := DeterminePlateAngle(Rect,TBitmapPlot(CurrentMNode).Picture.Bitmap,LogForm.Visible,Positions);
      if not IsNan(Angle) then begin
        for i := 0 to High(Positions) do
          with Rect do
            if Positions[i] >= 0 then
              if Abs(Top-Bottom) > Abs(Left-Right) then
                SetPixel(Left+Round(Positions[i]),Top+i)
              else
                SetPixel(Left+i,Top+Round(Positions[i]));
        if Angle < 0 then
          PlateAngle := RadToDeg(-Angle)
        else
          PlateAngle := RadToDeg(Pi-Angle);
        Application.MessageBox(PChar(Format('%g degrees', [PlateAngle])),'Plate Angle',0);
      end
    end
  else
    raise EReportException.Create('Please select an area on the picture');
end;

procedure TOverlayForm.PlateButtonClick(Sender: TObject);
var
  s: string;
  Bounds: array [0..3] of TPoint;
  I: Integer;
begin
  if not Assigned(CurrentMNode) or not (CurrentMNode is TBitmapPlot) then
    Exit;
  with TBitmapPlot(CurrentMNode) do begin
    for I := 0 to 3 do begin
      if Point(i,Bounds[i],False) then
        raise EReportException.Create('All 4 scan boundary points must be set');
      Bounds[i].Y := Picture.Height - Bounds[i].Y;
    end;
    s := FloatToStr(PlateAngle);
    if not InputQuery('Plate Angle', 'Degrees:', s) then
      Exit;
    PlateAngle := StrToFloatEx(s);
    ScanPlateSpectrum(-PlateAngle,Bounds);
  end;
  ShowItem(BaseNode);
end;

procedure TOverlayForm.PlotOperateButtonClick(Sender: TObject);
begin
  PlotPopupMenu.PopupComponent := PlotOperateButton;
  PlotPopupMenu.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;

function TOverlayForm.Point(i: Integer; out APoint: TPoint; DeScale: Boolean): Boolean;
var
  Base: Integer;
begin
  with CurrentMNode as TBitmapPlot do begin
    Base := 2*i + IndexOfSetting('TopLeftX');
    APoint.X := Settings[Base];
    APoint.Y := Settings[Base+1];
    Result := (APoint.X=0) and (APoint.Y=0);
    if DeScale then
      DeScaleCoords(APoint.x,APoint.y,True);
  end;
end;

procedure TOverlayForm.CopyPeaksButtonClick(Sender: TObject);
var
  Stream: THugeMemoryStream;
  s: string;
  i: Integer;
  procedure Process(Plot: TPlot);
  var
    i: Integer;
  begin
    for i := 0 to Plot.nPeaks-1 do begin
      s := FloatToStr(Plot.Peaks.Peaks[i].Position) + sLineBreak;
      { TODO: Write ohther fields }
      Stream.Write(s[1], Length(s));
    end;
  end;
begin
  if not Assigned(CurrentMNode) then
    Exit;
  Stream := THugeMemoryStream.Create;
  try
    if CurrentMNode is TOverlays then
      with TOverlays(CurrentMNode) do
        for i := 0 to nPlots - 1 do
          Process(Plots[i])
    else
      Process(CurrentMNode as TPlot);
    Stream.CopyToClipboard(CF_PREFTEXT);
  finally
    Stream.Free;
  end;
end;

procedure TOverlayForm.MNodeChange(Sender: TMnode; Change: TMNodeChange; Index: Integer);
begin
  if Visible and (Change = mnGraphicChanged) then
    GraphD.PlotChanged;
  inherited;
end;

function TOverlayForm.MoveUpDown(Shift: Integer; Test: Boolean): Boolean;
begin
  Result := inherited MoveUpDown(Shift, Test);
  if not Test and Result then
    MainForm.ConsiderReplot;
end;

procedure TOverlayForm.UpdateActions;
begin
  inherited UpdateActions;
  { This is used to defer plot updates to avoid multiple replots }
  if not (FPlotNeeded and CanReStuff) then
    Exit;
  if CurrentMNode is TBitmapPlot then
    { No action needed }
  else if Assigned(CurrentMNode) then
      ShowCurrentPlot
  else
    GraphD.PlotChanged;
  FPlotNeeded := False;
end;

procedure TOverlayForm.PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  Pixel: TColor;
  s: string;
begin
  if Selecting then
    UpdateSelection(X, Y, True);
  ScaleCoords(X,Y);
  StatusBar.Panels[0].Text := 'Pixels';
  StatusBar.Panels[2].Text := IntToStr(X); { TODO : Scale to true pixels }
  StatusBar.Panels[4].Text := IntToStr(Y);
  if CurrentMNode is TBitmapPlot then
    with TBitmapPlot(CurrentMNode) do
      if Picture.Width > 0 then begin
        StatusBar.Panels[6].Text := RoundedStr(HMin + X *(HMax-HMin)/nDF, (HMax-HMin)/nDF);
        StatusBar.Panels[8].Text := RoundedStr(IMin + Y *(IMax-IMin)/Picture.Height, (IMax-IMin)/Picture.Height);
        s := '';
        {$IFDEF MSWINDOWS}
        if Picture.Graphic is TBitmap then begin
          Pixel := Picture.Bitmap.Canvas.Pixels[X,Y];
          if Pixel <> -1 then
            s := Format('R:%d G:%d B:%d', [GetRValue(Pixel), GetGValue(Pixel), GetBValue(Pixel)]);
        end;
        {TODO: Fix LCL so that GetPixel works also}
        {$ENDIF}
        StatusBar.Panels[9].Text := s;
      end
  else begin
    StatusBar.Panels[6].Text := '';
    StatusBar.Panels[8].Text := '';
  end;
end;

procedure TOverlayForm.ScaleCoords(var X, Y: Integer);
var
  Rect: TRect;
begin
  { Convert from client Co-ordinates to bitmap coordinates }
  if not (CurrentMNode is TBitmapPlot) then
    Exit;
  Rect := PaintBox.ClientRect;
  if Rect.Right <> Rect.Left then
    X := Round((X-Rect.Left)/(Rect.Right-Rect.Left)*TBitmapPlot(CurrentMNode).Picture.Width);
  if Rect.Bottom <> Rect.Top then
    Y := Round((Y-Rect.Bottom)/(Rect.Top-Rect.Bottom)*TBitmapPlot(CurrentMNode).Picture.Height);
end;

function TOverlayForm.ScaleRect(Rect: TRect; InvertY:Boolean): TRect;
begin
  if not (CurrentMNode is TBitmapPlot) then
    Exit;
  Result := Rect;
  ScaleCoords(Result.Left, Result.Top);
  ScaleCoords(Result.Right, Result.Bottom);
  if InvertY then
    with TBitmapPlot(CurrentMNode).Picture do begin
      Result.Top := Height - Result.Top;
      Result.Bottom := Height - Result.Bottom;
  end;
  InOrder(Result.Left, Result.Right);
  InOrder(Result.Top, Result.Bottom);
end;

procedure TOverlayForm.PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  v, Base: Integer;
begin
  if (MouseSetting > 1) and Assigned(CurrentMNode) and (CurrentMNode is TBitmapPlot) then
    with CurrentMNode as TBitmapPlot do begin
      Base := IndexOfSetting('TopLeftX');
      ScaleCoords(X,Y);
      v := X;
      if MouseSetting >= Base then
        SetSetting(MouseSetting+1,Y)
      else if MouseSetting >= IndexOfSetting('BaselinePixel') then
        v := Y;
      SetSetting(MouseSetting,v);
      PaintBox.Invalidate;
      if AllCorners and (MouseSetting in [Base,Base+2,Base+4]) then begin
        MouseSetting := MouseSetting+2;
        Exit;
      end;
    end;
  if MouseSetting > 1 then begin
    MouseSetting := -1;
    Exit;
  end;
  if Button = mbLeft then begin
    CancelSelection;
    Selecting := True;
    FSelectedArea.Left := X;
    FSelectedArea.Top := Y;
  end;
end;

procedure TOverlayForm.PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) and Selecting then begin
    UpdateSelection(X, Y, True);
    Selecting := False;
  end;
  UpdateAlwaysVisible(False);
end;

procedure TOverlayForm.PaintBoxPaint(Sender: TObject);
var
  i: Integer;
  procedure ShowMark(i:Integer);
  const w:Integer = 4;
  var
    P: TPoint;
  begin
    if Point(i,P,True) then
      Exit;
    with P do begin
      with PaintBox.Canvas do begin
        Brush.Color := clRed;
        Rectangle(x-1,y+w,x+2,y-w-1);
        Rectangle(x-w,y+1,x+w+1,y-2);
      end;
    end;
  end;
  procedure Join(a,b: Integer);
  var
    c,d: TPoint;
  begin
    if Point(a,c,True) or Point(b,d,True) then
      Exit;
    with PaintBox.Canvas do begin
      MoveTo(c.X,c.Y);
      LineTo(d.X,d.Y);
    end;
  end;
begin
  PaintBox.Canvas.FillRect(PaintBox.ClientRect);
  if Assigned(CurrentMNode) and (CurrentMNode is TBitmapPlot) then
    with CurrentMNode as TBitmapPlot do
      with PaintBox.Canvas do begin
        PaintBox.Canvas.StretchDraw(PaintBox.ClientRect, Picture.Graphic);
        Pen.Color := clBlack;
        for i := 0 to 3 do
          ShowMark(i);
        Pen.Color := clRed;
        Join(0,1);
        Join(1,3);
        Join(3,2);
        Join(2,0);
      end;
  DrawSelectedArea;
end;

procedure TOverlayForm.ZoomTo(Rect: TRect; ScreenCords: Boolean);
var
  Xscale, Yscale: Double;
  Zoom: Double;
  procedure Adjust(var S, E: Integer; Scale: Double);
  var
    D: Integer;
  begin
    if E < S then begin
      D := E;
      E := S;
      S := D;
    end;
    D := Round((E-S)*(Scale-1)/2);
    Dec(S,D);
    Inc(E,D);
    if S < 0 then begin
      E := E - S;
      S := 0;
    end;
  end;
begin
  if Assigned(CurrentMNode) and (CurrentMNode is TBitmapPlot) then
    with CurrentMNode as TBitmapPlot do begin
      if ScreenCords then
        Rect := ScaleRect(Rect,True);
      CancelSelection;
      { Adjust desired rectangle so that the full required range will visible }
      if (ScrollBox.ClientHeight < 2) or (ScrollBox.ClientWidth < 2) then
        Exit; { Avoid errors later }
      Yscale := ScrollBox.ClientHeight/Abs(Rect.Bottom - Rect.Top);
      Xscale := ScrollBox.ClientWidth/Abs(Rect.Right - Rect.Left);
      if Xscale > Yscale then begin
        Adjust(Rect.Left, Rect.Right, Xscale/Yscale);
        Adjust(Rect.Top, Rect.Bottom, 1);
      end else begin
        Adjust(Rect.Left, Rect.Right, 1);
        Adjust(Rect.Top, Rect.Bottom, Yscale/Xscale);
      end;
      Zoom := Min(Xscale,Yscale);
      ScrollBox.VertScrollBar.Visible := True;
      ScrollBox.HorzScrollBar.Visible := True;
      ScrollBox.HorzScrollBar.Position := 0;
      ScrollBox.VertScrollBar.Position := 0;
      PaintBox.SetBounds(0, 0, Round(Picture.Width*Zoom), Round(Picture.Height*Zoom));
      ScrollBox.HorzScrollBar.Position := Round(Rect.Left*Zoom);
      ScrollBox.VertScrollBar.Position := Round(Rect.Top*Zoom);
      ZoomPicture := False
    end;
end;

procedure TOverlayForm.SetZoom(Zoom: Double);
var
  OldZoom, Scale: Double;
  Rect:TRect;
  procedure NewBorder(out S, E: Integer; Offset, Range:Integer);
  begin
    Scale := Zoom/OldZoom;
    S := Offset + Round(Range*(1-1/Scale)/2);
    E := S + Round(Range/Scale);
  end;
begin
  if Assigned(CurrentMNode) and (CurrentMNode is TBitmapPlot) then
    with CurrentMNode as TBitmapPlot do begin
      OldZoom := PaintBox.Width/Picture.Width;
      if Zoom < 0 then
        Zoom := Abs(Zoom)* OldZoom;
      NewBorder(Rect.Left, Rect.Right, ScrollBox.HorzScrollBar.Position, ScrollBox.ClientWidth);
      NewBorder(Rect.Top, Rect.Bottom, ScrollBox.VertScrollBar.Position, ScrollBox.ClientHeight);
      ZoomTo(Rect,True);
    end;
end;

procedure TOverlayForm.ZoomButtonClick(Sender: TObject);
begin
  if FAreaSelected then
    ZoomTo(FSelectedArea,True)
  else
    SetZoom(-2);
end;

procedure TOverlayForm.ZoomOutButtonClick(Sender: TObject);
begin
  SetZoom(-0.5);
end;

procedure TOverlayForm.ResetZoomButtonClick(Sender: TObject);
begin
  if Assigned(CurrentMNode) and (CurrentMNode is TBitmapPlot) then
    with CurrentMNode as TBitmapPlot do begin
      ScrollBox.VertScrollBar.Visible := False;
      ScrollBox.HorzScrollBar.Visible := False;
      ZoomTo(Rect(0,0,Picture.Width,Picture.Height),False);
      ZoomPicture := True;
      PaintBox.Invalidate;
    end;
end;

procedure TOverlayForm.OneToOneButtonClick(Sender: TObject);
begin
  SetZoom(1);
end;

end.

