unit RC4;
{$H+}
interface

uses Classes, PDFStream, {$IFNDEF FPC} pgmd5 {$ELSE} md5 {$ENDIF};

type

  { TRC4DecryptionStream }

  TRC4DecryptionStream = class(TPDFStream)
    Key: TMD5Digest;
    KeyLength: Integer;
    State: array [0..255] of Byte;
    x, y: Byte;
    buf: Integer;
    constructor Create(AStream: TStream; AKey:TMD5Digest; AKeyLength: Integer);
    function NextByte: Byte; override;
  end;


implementation

constructor TRC4DecryptionStream.Create(AStream: TStream; AKey: TMD5Digest; AKeyLength: Integer);
var
  i, i1, t: Integer;
  i2: Cardinal;
begin
  inherited Create(AStream);
  Key := AKey;
  KeyLength := AKeyLength;
  x := 0;
  y := 0;
  for i := 0 to 255 do
    State[i] := i;
  i1 := 0;
  i2 := 0;
  for i := 0 to 255 do begin
    i2 := (Key[i1] + State[i] + i2) mod 256;
    t := State[i];
    State[i] := State[i2];
    State[i2] := t;
    i1 := (i1+1) mod KeyLength;
  end;
end;

function TRC4DecryptionStream.NextByte: Byte;
var
  tx, ty: Integer;
begin
  if Eof or (Stream.Read(Result,1) <> 1) then begin
    Eof := True;
    Exit;
  end;
  x := (x + 1) mod 256;
  y := (State[x]+y) mod 256;
  tx := State[x];
  ty := State[y];
  State[x] := ty;
  State[y] := tx;
  Result := Result xor State[(tx+ty) mod 256];
end;

end.
