program PgopherU;

{$R 'version.res' 'version.rc'}

uses
  {$IFDEF FASTMM4}
  FastMM4,
  {$ENDIF }
  Vcl.Forms,
  Windows,
  Sysutils,
  AirVac in '..\utils\AirVac.pas',
  CEig in '..\utils\CEig.pas',
  CharType in '..\utils\CharType.pas',
  Clock in '..\utils\Clock.pas',
  ComplexMatrix in '..\utils\ComplexMatrix.pas',
  EigLA in '..\utils\EigLA.pas',
  Expr in '..\utils\Expr.pas',
  f2c in '..\utils\f2c.pas',
  FastMMUsageTracker in '..\utils\FastMMUsageTracker.pas' {fFastMMUsageTracker},
  FuncFit in '..\utils\FuncFit.pas',
  Huge in '..\utils\Huge.pas',
  IntVec in '..\utils\IntVec.pas',
  LapackLSQ in '..\utils\LapackLSQ.pas',
  Lapack in '..\utils\Lapack.pas',
  LineStrm in '..\utils\LineStrm.pas',
  LongName in '..\utils\LongName.pas',
  LSQSpline in '..\utils\LSQSpline.pas',
  LUDecomp in '..\utils\LUDecomp.pas',
  MathSup in '..\utils\MathSup.pas',
  MatrixOps in '..\utils\MatrixOps.pas',
  MatrixVec in '..\utils\MatrixVec.pas',
  NextTok in '..\utils\NextTok.pas',
  njExpr in '..\utils\njExpr.pas',
  nj in '..\utils\nj.pas',
  PiecewisePoly in '..\utils\PiecewisePoly.pas',
  Profile in '..\utils\Profile.pas',
  PropHelp in '..\utils\PropHelp.pas',
  QuantumNumber in '..\utils\QuantumNumber.pas',
  SavitzkyGolay in '..\utils\SavitzkyGolay.pas',
  ShellSort in '..\utils\ShellSort.pas',
  SmoothSpline in '..\utils\SmoothSpline.pas',
  SplineControl in '..\utils\SplineControl.pas',
  StackDump in '..\utils\StackDump.pas',
  StackTrace in '..\utils\StackTrace.pas',
  Sysinfo in '..\utils\Sysinfo.pas',
  TempStrm in '..\utils\TempStrm.pas',
  TextAssign in '..\utils\TextAssign.pas',
  TextStrm in '..\utils\TextStrm.pas',
  UCompat in '..\utils\UCompat.pas',
  Vector in '..\utils\Vector.pas',
  WignerD in '..\utils\WignerD.pas',
  Wofz in '..\utils\Wofz.pas',
  Worker in '..\utils\Worker.pas',
  AlEdit in '..\wutils\AlEdit.pas',
  CanCan in '..\wutils\CanCan.pas',
  ComboFix in '..\wutils\ComboFix.pas',
  CompatMsg in '..\wutils\CompatMsg.pas',
  Detach in '..\wutils\Detach.pas',
  EditExtr in '..\wutils\EditExtr.pas',
  EditLog in '..\wutils\EditLog.pas',
  ExActn in '..\wutils\ExActn.pas',
  ExpCan in '..\wutils\ExpCan.pas',
  ExportG in '..\wutils\ExportG.pas',
  FileNameEdit in '..\wutils\FileNameEdit.pas',
  FixDlg in '..\wutils\FixDlg.pas' {FixedFontForm},
  FixFnt in '..\wutils\FixFnt.pas',
  FixForm in '..\wutils\FixForm.pas',
  FrameGrp in '..\wutils\FrameGrp.pas',
  FxFntDlg in '..\wutils\FxFntDlg.pas',
  GMarkDlg in '..\wutils\GMarkDlg.pas',
  Gmarks in '..\wutils\Gmarks.pas',
  GPenDlg in '..\wutils\GPenDlg.pas',
  GraphI in '..\wutils\GraphI.pas',
  GraphM in '..\wutils\GraphM.pas',
  GraphMrk in '..\wutils\GraphMrk.pas' {MarkDialog},
  GraphPen in '..\wutils\GraphPen.pas' {PenDialog},
  Graphs in '..\wutils\Graphs.pas',
  GridEx in '..\wutils\GridEx.pas',
  GStyle in '..\wutils\GStyle.pas',
  Handles in '..\wutils\Handles.pas',
  HugeClip in '..\wutils\HugeClip.pas',
  LogControl in '..\wutils\LogControl.pas',
  LogFiDlg in '..\wutils\LogFiDlg.pas' {LogFindDlg},
  LogFind in '..\wutils\LogFind.pas',
  MarkChse in '..\wutils\MarkChse.pas' {MarkChoose},
  MDIChildForm in '..\wutils\MDIChildForm.pas',
  MDIFix in '..\wutils\MDIFix.pas',
  MuScroll in '..\wutils\MuScroll.pas',
  NewSpin in '..\wutils\NewSpin.pas',
  NGrid in '..\wutils\NGrid.pas',
  PenChse in '..\wutils\PenChse.pas' {PenChoose},
  PHtmlHelpViewer in '..\wutils\PHtmlHelpViewer.pas',
  Prevwdlg in '..\wutils\Prevwdlg.pas' {PrintPreviewForm},
  PrintPre in '..\wutils\PrintPre.pas',
  ProfileForm in '..\wutils\ProfileForm.pas' {ProfilerForm},
  ProjAbout in '..\wutils\ProjAbout.pas' {AboutBox},
  PropStrm in '..\wutils\PropStrm.pas',
  QuantumSpin in '..\wutils\QuantumSpin.pas',
  ResActn in '..\wutils\ResActn.pas',
  ScrlCtrl in '..\wutils\ScrlCtrl.pas',
  SlaveEdit in '..\wutils\SlaveEdit.pas',
  Split in '..\wutils\Split.pas',
  SrchStrs in '..\wutils\SrchStrs.pas',
  ToolBarEx in '..\wutils\ToolBarEx.pas',
  WCompat in '..\wutils\WCompat.pas',
  WhatsThis in '..\wutils\WhatsThis.pas',
  pgAVL_Tree in '..\lutils\xml\pgAVL_Tree.pas',
  pgDOM in '..\lutils\xml\pgDOM.pas',
  pgXMLRead in '..\lutils\xml\pgXMLRead.pas',
  pgXMLWrite in '..\lutils\xml\pgXMLWrite.pas',
  GraphicColor in '..\GraphicEx\GraphicColor.pas',
  GraphicCompression in '..\GraphicEx\GraphicCompression.pas',
  GraphicEx in '..\GraphicEx\GraphicEx.pas',
  GraphicStrings in '..\GraphicEx\GraphicStrings.pas',
  MZLib in '..\GraphicEx\MZLib.pas',
  Abelian in 'Abelian.pas',
  ApplyFrm in 'ApplyFrm.pas' {ApplyForm},
  Atomic in 'Atomic.pas',
  CalFrm in 'CalFrm.pas' {CalForm},
  CalSource in 'CalSource.pas',
  CheckImport in 'CheckImport.pas',
  CheckJB95 in 'CheckJB95.pas',
  CheckOverlay in 'CheckOverlay.pas',
  CheckPgopher in 'CheckPgopher.pas',
  CheckSpecView in 'CheckSpecView.pas',
  ChildForm in 'ChildForm.pas',
  CommandLine in 'CommandLine.pas',
  CompressDlg in 'CompressDlg.pas' {CompressForm},
  ConstFrm in 'ConstFrm.pas' {ConstantsForm},
  Constrain in 'Constrain.pas',
  D3hImport in 'D3hImport.pas',
  Decomp in 'Decomp.pas',
  DRintensity in 'DRintensity.pas',
  DushinskyFrm in 'DushinskyFrm.pas' {DushinskyForm},
  ExpBitmap in 'ExpBitmap.pas',
  ExpPlot in 'ExpPlot.pas',
  ExternalList in 'ExternalList.pas',
  Fitter in 'Fitter.pas',
  FormUtils in 'FormUtils.pas',
  Global in 'Global.pas',
  GraphRange in 'GraphRange.pas',
  Hitran in 'Hitran.pas',
  HundA in 'HundA.pas',
  I2 in 'I2.pas',
  ImportACDD in 'ImportACDD.pas',
  ImportCALPGM in 'ImportCALPGM.pas',
  ImportJB95 in 'ImportJB95.pas',
  ImportLmatrix in 'ImportLmatrix.pas',
  ImportSpecView in 'ImportSpecView.pas',
  ImportSTROTAB in 'ImportSTROTAB.pas',
  Interlock in 'Interlock.pas',
  JPLCat in 'JPLCat.pas',
  LevelFrm in 'LevelFrm.pas' {LevelForm},
  LevelLister in 'LevelLister.pas',
  LevelPlotter in 'LevelPlotter.pas',
  Life in 'Life.pas',
  LineExportOpt in 'LineExportOpt.pas' {LineExportOptions},
  LineFrm in 'LineFrm.pas' {LineForm},
  LineOpt in 'LineOpt.pas' {LineFrmOptDlg},
  LmatrixFrm in 'LmatrixFrm.pas' {LMatrixForm},
  LogUnit in 'LogUnit.pas' {LogForm},
  Main in 'Main.pas' {MainForm},
  MatrixElements in 'MatrixElements.pas',
  Mixture in 'Mixture.pas',
  MNodeClip in 'MNodeClip.pas',
  MNodeColour in 'MNodeColour.pas',
  MNode in 'MNode.pas',
  OAsymT in 'OAsymT.pas',
  Obs in 'Obs.pas',
  ObsSelect in 'ObsSelect.pas',
  OscFields in 'OscFields.pas',
  Overlay in 'Overlay.pas',
  OverlaySumFitter in 'OverlaySumFitter.pas',
  OvrlyFrm in 'OvrlyFrm.pas' {OverlayForm},
  PartFunc in 'PartFunc.pas',
  PgopherImport in 'PgopherImport.pas',
  PGWork in 'PGWork.pas',
  Plate in 'Plate.pas',
  PlotDataSource in 'PlotDataSource.pas',
  PlotFrm in 'PlotFrm.pas' {PlotForm},
  PlotOC in 'PlotOC.pas',
  Plotter in 'Plotter.pas',
  PopFunc in 'PopFunc.pas',
  Progress in 'Progress.pas' {ProgressForm},
  QuantumMath in 'QuantumMath.pas',
  ReadBinary in 'ReadBinary.pas' {BinaryImportDlg},
  RenForm in 'RenForm.pas' {RenameForm},
  ResidFrm in 'ResidFrm.pas' {ResidualForm},
  SampleMols in 'SampleMols.pas',
  SettingsForm in 'SettingsForm.pas',
  Settings in 'Settings.pas',
  SimpleQnos in 'SimpleQnos.pas',
  SmoothDlg in 'SmoothDlg.pas' {SmoothForm},
  SpectrumPlot in 'SpectrumPlot.pas',
  StateInfo in 'StateInfo.pas' {StatesForm},
  StaticField in 'StaticField.pas',
  SymmetricTop in 'SymmetricTop.pas',
  SymT in 'SymT.pas',
  SymUtils in 'SymUtils.pas',
  TranInfo in 'TranInfo.pas' {TransitionForm},
  Vib in 'Vib.pas',
  Channel in '..\lutils\Channel.pas',
  DataFitter in '..\lutils\DataFitter.pas',
  DataSource in '..\lutils\DataSource.pas',
  DataTypes in '..\lutils\DataTypes.pas',
  DatLoader in '..\lutils\DatLoader.pas',
  DrLoader in '..\lutils\DrLoader.pas',
  DrvLoader in '..\lutils\DrvLoader.pas',
  ExpPlotLoader in '..\lutils\ExpPlotLoader.pas',
  JDXLoader in '..\lutils\JDXLoader.pas',
  NLFit in '..\lutils\NLFit.pas',
  OPJLoader in '..\lutils\OPJLoader.pas',
  OvrLoader in '..\lutils\OvrLoader.pas',
  PersistentVariables in '..\lutils\PersistentVariables.pas',
  PSLoader in '..\lutils\PSLoader.pas',
  SIFLoader in '..\lutils\SIFLoader.pas',
  SPALoader in '..\lutils\SPALoader.pas',
  SPCLoader in '..\lutils\SPCLoader.pas',
  SplineExpr in '..\lutils\SplineExpr.pas',
  SPLoader in '..\lutils\SPLoader.pas',
  SVD in '..\lutils\SVD.pas',
  TabbedLine in '..\lutils\TabbedLine.pas',
  Units in '..\lutils\Units.pas',
  AddStat in '..\lforms\AddStat.pas' {AddOnStatusDlg},
  AdvOpt in '..\lforms\AdvOpt.pas' {AdvDlg},
  Gendlg in '..\lforms\Gendlg.pas' {NLFitDlg},
  IPlotLoader in '..\lforms\IPlotLoader.pas',
  PickDest in '..\lforms\PickDest.pas' {PickDestForm},
  SplineOpt in '..\lforms\SplineOpt.pas' {SplineDlg},
  ASCII85 in 'PDFReader\ASCII85.pas',
  CCITT in 'PDFReader\CCITT.pas',
  Flate in 'PDFReader\Flate.pas',
  LZW in 'PDFReader\LZW.pas',
  PDFreader in 'PDFReader\PDFreader.pas',
  PDFStream in 'PDFReader\PDFStream.pas',
  pgmd5 in 'PDFReader\pgmd5.pas',
  RC4 in 'PDFReader\RC4.pas',
  VibPart in 'VibPart.pas',
  MNodeExpr in 'MNodeExpr.pas',
  TranFunc in 'TranFunc.pas',
  zMatrix in 'zMatrix.pas',
  VibGridFrm in 'VibGridFrm.pas' {VibGridForm},
  zMatrixFrm in 'zMatrixFrm.pas' {ZMatrixForm},
  InternalCoords in 'InternalCoords.pas',
  InternalCoordsFrm in 'InternalCoordsFrm.pas' {InternalCoordsForm},
  CartesianDisplacementsFrm in 'CartesianDisplacementsFrm.pas' {CartesianDisplacementsForm},
  SymmetryCoordsFrm in 'SymmetryCoordsFrm.pas' {SymmetryCoordsForm},
  ImportVIBCA in 'ImportVIBCA.pas',
  MNodeFunc in 'MNodeFunc.pas',
  ExoMol in 'ExoMol.pas',
  LoomisWood in 'LoomisWood.pas',
  PeakFitFrm in 'PeakFitFrm.pas' {PeakFitForm},
  LoomisWoodFrm in 'LoomisWoodFrm.pas' {LoomisWoodForm},
  Peaks in 'Peaks.pas',
  Peak in '..\lutils\Peak.pas',
  BigSet in '..\utils\BigSet.pas',
  EigBlock in '..\utils\EigBlock.pas',
  FitControlFrm in 'FitControlFrm.pas' {FitControlForm},
  VibPlotFrm in 'VibPlotFrm.pas' {VibPlotForm},
  Exporter in 'Exporter.pas',
  NuclearInfo in '..\utils\NuclearInfo.pas',
  SizeHelpers in '..\wutils\SizeHelpers.pas',
  AutoFitFrm in 'AutoFitFrm.pas' {AutoFitForm},
  BaselineFrm in 'BaselineFrm.pas' {BaselineForm},
  PeakFindFrm in 'PeakFindFrm.pas' {PeakFindForm},
  Importer in 'Importer.pas',
  ImportFrm in 'ImportFrm.pas' {ImportForm},
  WindowsXLSLoader in '..\lutils\WindowsXLSLoader.pas',
  XLSXLoader in '..\lutils\XLSXLoader.pas',
  FITSLoader in '..\lutils\FITSLoader.pas',
  SSLoader in '..\lutils\SSLoader.pas',
  ZipLoader in '..\lutils\ZipLoader.pas',
  ItemStrm in '..\lutils\ItemStrm.pas',
  OverlayCalcFrm in 'OverlayCalcFrm.pas' {OverlayCalcForm},
  DeGlitchFrm in 'DeGlitchFrm.pas' {DeGlitchForm},
  OpusLoader in '..\lutils\OpusLoader.pas',
  AutoFit in 'AutoFit.pas';

{$R *}

begin
  {$IFDEF UNICODE}FormatSettings.{$ENDIF}DecimalSeparator := '.'; { See comment in HandleCommandLine; required here for FixedSpin to load from dfm files }
  if not IsDebuggerPresent then
    StackWatch(True);
  NeverSleepOnMMThreadContention := True; { Good for a factor of two on fast multicore systems. }
  { Note that XE3 and XE8 (and probably other versions) have a bug that means this flag is ignored in 64 bit modes,
    so use FASTMM4 instead, which gives better performance all round }
  Application.Initialize;
  Application.MainFormOnTaskbar := True;
  Application.UpdateFormatSettings := False; { Otherwise system settings change might change decimal separator }
  Application.Title := 'Pgopher';
  Application.HelpFile := 'pgopher.chm';
  Application.CreateForm(TMainForm, MainForm);
  Application.CreateForm(TConstantsForm, ConstantsForm);
  Application.CreateForm(TOverlayForm, OverlayForm);
  Application.CreateForm(TTransitionForm, TransitionForm);
  Application.CreateForm(TLogForm, LogForm);
  Application.CreateForm(TProgressForm, ProgressForm);
  Application.CreateForm(TLineExportOptions, LineExportOptions);
  Application.CreateForm(TBinaryImportDlg, BinaryImportDlg);
  Application.CreateForm(TCalForm, CalForm);
  Application.CreateForm(TSmoothForm, SmoothForm);
  Application.CreateForm(TLineFrmOptDlg, LineFrmOptDlg);
  Application.CreateForm(TResidualForm, ResidualForm);
  Application.CreateForm(TPickDestForm, PickDestForm);
  Application.CreateForm(TStatesForm, StatesForm);
  Application.CreateForm(TLoomisWoodForm, LoomisWoodForm);
  Application.CreateForm(TFitControlForm, FitControlForm);
  Application.CreateForm(TLineForm, LineForm);
  Application.CreateForm(TAutoFitForm, AutoFitForm);
  Application.CreateForm(TBaselineForm, BaselineForm);
  Application.CreateForm(TPeakFindForm, PeakFindForm);
  Application.CreateForm(TImportForm, ImportForm);
  Application.CreateForm(TDeGlitchForm, DeGlitchForm);
  LevelForm := TLevelPlotter.Create(Application); { Confuses Delphi to use automatic mechanism as above }
  HandleCommandLine;
  Application.Run;
end.
