
CLEANLFM = cleanlfm -lazarus -c -t -v -fi -posonly -zapfont

DFMS = ApplyFrm.dfm CalFrm.dfm ConstFrm.dfm LevelFrm.dfm LineExportOpt.dfm LineFrm.dfm \
	LineOpt.dfm LogUnit.dfm Main.dfm OvrlyFrm.dfm PlotFrm.dfm Progress.dfm \
	ReadBinary.dfm RenForm.dfm ResidFrm.dfm SmoothDlg.dfm StateInfo.dfm \
	TranInfo.dfm

.SUFFIXES: .dfm .lfm .lrs

all: lrss

lrss: $(DFMS:.dfm=.lrs)

lfms: $(DFMS:.dfm=.lfm)

patches: $(DFMS:.lfm=.lfm.patch)

%.lrs: %.lfm
	lazres $@ $<

%.lfm: %.dfm
	$(CLEANLFM) $<
	cp $< $<.orig
	cp $@ $@.orig
	-difflfm -apply $@.diff $@

%.lfm.patch: %.dfm
	$(CLEANLFM) -o$*.lfm.orig $<
	-diff -uw $*.lfm.orig $*.lfm >$@
	rm $*.lfm.orig

clean:
	-rm *.o *.ppu *.dcu


veryclean: clean
	rm *.bak *.~* *~

.SECONDARY:
