program pgoU;

{$APPTYPE CONSOLE}

{$R *.res}

{$R 'version.res' 'version.rc'}

uses
  {$IFDEF FASTMM4}
  FastMM4,
  {$ENDIF }
  System.SysUtils,
  Windows,
  AirVac in '..\utils\AirVac.pas',
  CEig in '..\utils\CEig.pas',
  Clock in '..\utils\Clock.pas',
  ComplexMatrix in '..\utils\ComplexMatrix.pas',
  EigLA in '..\utils\EigLA.pas',
  Expr in '..\utils\Expr.pas',
  f2c in '..\utils\f2c.pas',
  FuncFit in '..\utils\FuncFit.pas',
  Huge in '..\utils\Huge.pas',
  IntVec in '..\utils\IntVec.pas',
  Lapack in '..\utils\Lapack.pas',
  LapackLSQ in '..\utils\LapackLSQ.pas',
  LineStrm in '..\utils\LineStrm.pas',
  LSQSpline in '..\utils\LSQSpline.pas',
  LUDecomp in '..\utils\LUDecomp.pas',
  MathSup in '..\utils\MathSup.pas',
  MatrixOps in '..\utils\MatrixOps.pas',
  MatrixVec in '..\utils\MatrixVec.pas',
  NextTok in '..\utils\NextTok.pas',
  nj in '..\utils\nj.pas',
  njExpr in '..\utils\njExpr.pas',
  PiecewisePoly in '..\utils\PiecewisePoly.pas',
  Profile in '..\utils\Profile.pas',
  PropHelp in '..\utils\PropHelp.pas',
  QuantumNumber in '..\utils\QuantumNumber.pas',
  SavitzkyGolay in '..\utils\SavitzkyGolay.pas',
  ShellSort in '..\utils\ShellSort.pas',
  SmoothSpline in '..\utils\SmoothSpline.pas',
  SplineControl in '..\utils\SplineControl.pas',
  Sysinfo in '..\utils\Sysinfo.pas',
  TextAssign in '..\utils\TextAssign.pas',
  TextStrm in '..\utils\TextStrm.pas',
  UCompat in '..\utils\UCompat.pas',
  Vector in '..\utils\Vector.pas',
  Wofz in '..\utils\Wofz.pas',
  Worker in '..\utils\Worker.pas',
  pgAVL_Tree in '..\lutils\xml\pgAVL_Tree.pas',
  pgDOM in '..\lutils\xml\pgDOM.pas',
  pgXMLRead in '..\lutils\xml\pgXMLRead.pas',
  pgXMLWrite in '..\lutils\xml\pgXMLWrite.pas',
  Channel in '..\lutils\Channel.pas',
  DataFitter in '..\lutils\DataFitter.pas',
  DataSource in '..\lutils\DataSource.pas',
  DataTypes in '..\lutils\DataTypes.pas',
  DatLoader in '..\lutils\DatLoader.pas',
  DrLoader in '..\lutils\DrLoader.pas',
  DrvLoader in '..\lutils\DrvLoader.pas',
  ExpPlotLoader in '..\lutils\ExpPlotLoader.pas',
  JDXLoader in '..\lutils\JDXLoader.pas',
  NLFit in '..\lutils\NLFit.pas',
  OPJLoader in '..\lutils\OPJLoader.pas',
  OvrLoader in '..\lutils\OvrLoader.pas',
  PersistentVariables in '..\lutils\PersistentVariables.pas',
  PSLoader in '..\lutils\PSLoader.pas',
  SIFLoader in '..\lutils\SIFLoader.pas',
  SPALoader in '..\lutils\SPALoader.pas',
  SPCLoader in '..\lutils\SPCLoader.pas',
  SplineExpr in '..\lutils\SplineExpr.pas',
  SPLoader in '..\lutils\SPLoader.pas',
  SVD in '..\lutils\SVD.pas',
  TabbedLine in '..\lutils\TabbedLine.pas',
  Units in '..\lutils\Units.pas',
  ExpCan in '..\wutils\ExpCan.pas',
  ExportG in '..\wutils\ExportG.pas',
  Gmarks in '..\wutils\Gmarks.pas',
  GraphI in '..\wutils\GraphI.pas',
  GraphM in '..\wutils\GraphM.pas',
  GStyle in '..\wutils\GStyle.pas',
  MZLib in '..\GraphicEx\MZLib.pas',
  Graphics in '..\wutils\console\Graphics.pas',
  Abelian in 'Abelian.pas',
  Atomic in 'Atomic.pas',
  CalSource in 'CalSource.pas',
  CheckImport in 'CheckImport.pas',
  CheckJB95 in 'CheckJB95.pas',
  CheckOverlay in 'CheckOverlay.pas',
  CheckPgopher in 'CheckPgopher.pas',
  CheckSpecView in 'CheckSpecView.pas',
  CommandLine in 'CommandLine.pas',
  Constrain in 'Constrain.pas',
  D3hImport in 'D3hImport.pas',
  Decomp in 'Decomp.pas',
  DRintensity in 'DRintensity.pas',
  ExpPlot in 'ExpPlot.pas',
  ExternalList in 'ExternalList.pas',
  Fitter in 'Fitter.pas',
  Global in 'Global.pas',
  GraphRange in 'GraphRange.pas',
  Hitran in 'Hitran.pas',
  HundA in 'HundA.pas',
  I2 in 'I2.pas',
  ImportACDD in 'ImportACDD.pas',
  ImportCALPGM in 'ImportCALPGM.pas',
  ImportJB95 in 'ImportJB95.pas',
  ImportLmatrix in 'ImportLmatrix.pas',
  Interlock in 'Interlock.pas',
  JPLCat in 'JPLCat.pas',
  LevelLister in 'LevelLister.pas',
  LevelPlotter in 'LevelPlotter.pas',
  Life in 'Life.pas',
  MatrixElements in 'MatrixElements.pas',
  Mixture in 'Mixture.pas',
  MNode in 'MNode.pas',
  MNodeColour in 'MNodeColour.pas',
  OAsymT in 'OAsymT.pas',
  Obs in 'Obs.pas',
  ObsSelect in 'ObsSelect.pas',
  OscFields in 'OscFields.pas',
  Overlay in 'Overlay.pas',
  OverlaySumFitter in 'OverlaySumFitter.pas',
  PartFunc in 'PartFunc.pas',
  PgopherImport in 'PgopherImport.pas',
  PGWork in 'PGWork.pas',
  PlotDataSource in 'PlotDataSource.pas',
  Plotter in 'Plotter.pas',
  PopFunc in 'PopFunc.pas',
  Progress in 'Progress.pas',
  QuantumMath in 'QuantumMath.pas',
  SimpleQnos in 'SimpleQnos.pas',
  SpectrumPlot in 'SpectrumPlot.pas',
  StaticField in 'StaticField.pas',
  SymmetricTop in 'SymmetricTop.pas',
  SymT in 'SymT.pas',
  SymUtils in 'SymUtils.pas',
  Vib in 'Vib.pas',
  Peaks in 'Peaks.pas',
  Peak in '..\lutils\Peak.pas',
  StackTrace in '..\utils\StackTrace.pas',
  StackDump in '..\utils\StackDump.pas',
  NuclearInfo in '..\utils\NuclearInfo.pas',
  SSLoader in '..\lutils\SSLoader.pas',
  WindowsXLSLoader in '..\lutils\WindowsXLSLoader.pas',
  XLSXLoader in '..\lutils\XLSXLoader.pas',
  ZipLoader in '..\lutils\ZipLoader.pas',
  FITSLoader in '..\lutils\FITSLoader.pas',
  MNodeExpr in 'MNodeExpr.pas',
  AutoFitHelper in 'AutoFitHelper.pas';

begin
  if not IsDebuggerPresent then
    StackWatch(True);
  NeverSleepOnMMThreadContention := True; { Good for a factor of two on fast multicore systems. }
                                          { Note that XE3 and XE8 at a minimum have a bug that means this flag is ignored in 64 bit modes }
  HandleCommandLine;
end.
