program pgopher;
{$I utils.inc}
{.$DEFINE CHECKHEAP}
uses
  {$IFDEF CHECKHEAP} heaptrc, {$ENDIF}
  {$IFDEF UNIX}
    cthreads,
    cwstring, { pulled in by LazUTF8, which is in turn pulled in by fpspreadsheet; must be early }
  {$ENDIF}
  {$IFDEF LINUX} ProxyFix, {$ENDIF}
  Classes, f2c, Lapack,
  {$IFDEF MSWINDOWS} LResources, {$ENDIF}

  Interfaces, SysUtils, Forms, Mixture, SymT, Main, LogUnit, LineFrm, StateInfo,
  DrvLoader, JDXLoader, ConstFrm, TranInfo, CommandLine, OAsymT, RenForm,
  CheckPgopher, HundA, Progress, ExpBitmap, ExpPlot, LineOpt,
  ResidFrm, Global, MNodeClip, ReadBinary, printer4lazarus, Obs, ImportCALPGM,
  Hitran, PlotFrm, LineExportOpt, Fitter, CalFrm, ApplyFrm, SmoothDlg, PickDest,
  lutils, lforms, ImportJB95, PartFunc, Vib, LevelPlotter, LevelFrm,
  ExternalList, CheckImport, SimpleQnos, zMatrixFrm, InternalCoordsFrm,
  InternalCoords, ExoMol, CompressDlg, LoomisWood, LoomisWoodFrm, Peaks,
  VibPlotFrm, VibGridFrm, LmatrixBaseFrm, LmatrixFrm, SymmetryCoordsFrm,
  CartesianDisplacementsFrm, DushinskyFrm, FitControlFrm, FixForm, AutoFitFrm,
  BaselineFrm, PeakFindFrm, Importer, ImportFrm, DeGlitchFrm, AutoFitHelper;

{$R Pgopher.res}

{$IFDEF MSWINDOWS}
var
  IconResource: TLResource;
  IconStream: TStringStream;
{$ENDIF}
begin
  {$IFDEF CHECKHEAP}
    GlobalSkipIfNoLeaks := True;
  {$ENDIf}
  Application.Initialize;
  Application.Title:='Pgopher';
  Application.UpdateFormatSettings:=False;
  DecimalSeparator := '.';
  if GetAllOnTaskBarMode then
    Application.TaskBarBehavior := tbMultiButton
  else
    Application.TaskBarBehavior := tbSingleButton;
  {$IFDEF MSWINDOWS}
  IconStream := nil;
  try
    IconResource := LazarusResources.Find('PGOPHER','ICO');
    if Assigned(IconResource) then begin
      IconStream := TStringStream.Create(IconResource.Value);
      Application.Icon.LoadFromStream(IconStream);
    end;
  except
  end;
  IconStream.Free;
  {$ENDIF}
  Application.CreateForm(TMainForm, MainForm);
  Application.CreateForm(TConstantsForm, ConstantsForm);
  Application.CreateForm(TStatesForm, StatesForm);
  Application.CreateForm(TTransitionForm, TransitionForm);
  Application.CreateForm(TProgressForm, ProgressForm);
  Application.CreateForm(TLineExportOptions, LineExportOptions);
  Application.CreateForm(TBinaryImportDlg, BinaryImportDlg);
  Application.CreateForm(TCalForm, CalForm);
  Application.CreateForm(TSmoothForm, SmoothForm);
  Application.CreateForm(TPickDestForm, PickDestForm);
  Application.CreateForm(TLineFrmOptDlg, LineFrmOptDlg);
  Application.CreateForm(TResidualForm, ResidualForm);
  Application.CreateForm(TLoomisWoodForm, LoomisWoodForm);
  Application.CreateForm(TFitControlForm, FitControlForm);
  Application.CreateForm(TAutoFitForm, AutoFitForm);
  Application.CreateForm(TBaselineForm, BaselineForm);
  Application.CreateForm(TPeakFindForm, PeakFindForm);
  Application.CreateForm(TLineForm, LineForm);
  Application.CreateForm(TImportForm, ImportForm);
  Application.CreateForm(TDeGlitchForm, DeGlitchForm);
  LevelForm := TLevelPlotter.Create(Application); { Slightly non-standard usage }
  HandleCommandLine;
  Application.Run;
end.

