#!/bin/bash
# Create tabslave.app package for Mac OS X using carbon
# 

#set -x
#set -v

CPU=`fpc -iTP`
OS=`fpc -iTO`
CPU=i386
OS=darwin
WIDGET=carbon
appname=tabslave

appfile=$HOME/compiled/$appname/$CPU-$OS-$WIDGET/$appname

appfolder=/tmp/$appname.app
zipfile=/tmp/$appname-MacOSX-$CPU-$WIDGET.app.zip
macosfolder=$appfolder/Contents/MacOS
plistfile=$appfolder/Contents/Info.plist

if [ -e $appfolder ]; then
  rm -rf $appfolder
fi
if [ -f $zipfile ]; then
  rm $zipfile
fi

if ! [ -e $appfile ]; then
    echo "$appfile does not exist"
else
    mkdir $appfolder
    mkdir $appfolder/Contents
    mkdir $appfolder/Contents/Frameworks
    mkdir $appfolder/Contents/MacOS
    mkdir $appfolder/Contents/Resources

    # copy executable
    install -c -m 755 $appfile $macosfolder/$appname

    # Create PkgInfo file.
    echo "APPL????" >$appfolder/Contents/PkgInfo

    # Create information property list file (Info.plist).
    install -c -m 755 tabslave.plist $appfolder/Contents/Info.plist

    install -c -m 755 tabslave.icns $appfolder/Contents/Resources/tabslave.icns

    cd /tmp
    zip -r $zipfile `basename $appfolder`
fi
