unit Lapack;
{$I utils.inc}
interface

uses MathSup;

{$IFDEF DCC}{$IFDEF WIN64}
  {.$DEFINE EXTDLL}
  { 64 bit delphi has some issues with linking external object files; in principle should accept gfortran
    output, but has problems with multiple files, RIP relative addressing and SEH tables. Compiling to .s
    and using yasm as the assembler produces useable output, but any exceptions in the lapack code will
    cause an immediate crash with no message. To debug, use an external dll compiled with fpc and gfortran }
{$ENDIF}{$ENDIF}

{ Blas routines }
{ Were in separate file, but linking restrictions with Delphi makes it more convenient to merge to one file }
function dasum_(var n: Integer; var dx: Double; var incx: Integer): Double; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function daxpy_(var n: Integer; var da: Double; var dx: Double; var incx: Integer; var dy: Double; var incy: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dcopy_(var n: Integer; var dx: Double; var incx: Integer; var dy: Double; var incy: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function lsame_(var ca: AnsiChar; var cb: AnsiChar; ca_len: Integer; cb_len: Integer): LongBool; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dgemm_(var transa: AnsiChar; var transb: AnsiChar; var m: Integer; var n: Integer; var k: Integer; var alpha: Double; var a: Double; var lda: Integer; var b: Double; var ldb: Integer; var beta: Double; var c__: Double; var ldc: Integer; transa_len: Integer; transb_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dgemv_(var trans: AnsiChar; var m: Integer; var n: Integer; var alpha: Double; var a: Double; var lda: Integer; var x: Double; var incx: Integer; var beta: Double; var y: Double; var incy: Integer; trans_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dger_(var m: Integer; var n: Integer; var alpha: Double; var x: Double; var incx: Integer; var y: Double; var incy: Integer; var a: Double; var lda: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dnrm2_(var n: Integer; var x: Double; var incx: Integer): Double; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dscal_(var n: Integer; var da: Double; var dx: Double; var incx: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dswap_(var n: Integer; var dx: Double; var incx: Integer; var dy: Double; var incy: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dsymv_(var uplo: AnsiChar; var n: Integer; var alpha: Double; var a: Double; var lda: Integer; var x: Double; var incx: Integer; var beta: Double; var y: Double; var incy: Integer; uplo_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dsyr2_(var uplo: AnsiChar; var n: Integer; var alpha: Double; var x: Double; var incx: Integer; var y: Double; var incy: Integer; var a: Double; var lda: Integer; uplo_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dsyr2k_(var uplo: AnsiChar; var trans: AnsiChar; var n: Integer; var k: Integer; var alpha: Double; var a: Double; var lda: Integer; var b: Double; var ldb: Integer; var beta: Double; var c__: Double; var ldc: Integer; uplo_len: Integer; trans_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dsyrk_(var uplo: AnsiChar; var trans: AnsiChar; var n: Integer; var k: Integer; var alpha: Double; var a: Double; var lda: Integer; var beta: Double; var c__: Double; var ldc: Integer; uplo_len: Integer; trans_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dtrmm_(var side: AnsiChar; var uplo: AnsiChar; var transa: AnsiChar; var diag: AnsiChar; var m: Integer; var n: Integer; var alpha: Double; var a: Double; var lda: Integer; var b: Double; var ldb: Integer; side_len: Integer; uplo_len: Integer; transa_len: Integer; diag_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dtrsm_(var side: AnsiChar; var uplo: AnsiChar; var transa: AnsiChar; var diag: AnsiChar; var m: Integer; var n: Integer; var alpha: Double; var a: Double; var lda: Integer; var b: Double; var ldb: Integer; side_len: Integer; uplo_len: Integer; transa_len: Integer; diag_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dtrmv_(var uplo: AnsiChar; var trans: AnsiChar; var diag: AnsiChar; var n: Integer; var a: Double; var lda: Integer; var x: Double; var incx: Integer; uplo_len: Integer; trans_len: Integer; diag_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function idamax_(var n: Integer; var dx: Double; var incx: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function ddot_(var n: Integer; var dx: Double; var incx: Integer; var dy: Double; var incy: Integer): Double; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function drot_(var n: Integer; var dx: Double; var incx: Integer; var dy: Double; var incy: Integer; var c: Double; var s: Double): Double; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};

function ztrmv_(var uplo: AnsiChar; var trans: AnsiChar; var diag: AnsiChar; var n: Integer; var a: Complex; var lda: Integer; var x: Complex; var incx: Integer; uplo_len: Integer; trans_len: Integer; diag_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zaxpy_(var n: Integer; var za: Complex; var zx: Complex; var incx: Integer; var zy: Complex; var incy: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zcopy_(var n: Integer; var zx: Complex; var incx: Integer; var zy: Complex; var incy: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zdotc_(var ret_val: Complex; var n: Integer; var zx: Complex; var incx: Integer; var zy: Complex; var incy: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zdscal_(var n: Integer; var da: Double; var zx: Complex; var incx: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zgemm_(var transa: AnsiChar; var transb: AnsiChar; var m: Integer; var n: Integer; var k: Integer; var alpha: Complex; var a: Complex; var lda: Integer; var b: Complex; var ldb: Integer; var beta: Complex; var c__: Complex; var ldc: Integer; transa_len: Integer; transb_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zgemv_(var trans: AnsiChar; var m: Integer; var n: Integer; var alpha: Complex; var a: Complex; var lda: Integer; var x: Complex; var incx: Integer; var beta: Complex; var y: Complex; var incy: Integer; trans_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zgerc_(var m: Integer; var n: Integer; var alpha: Complex; var x: Complex; var incx: Integer; var y: Complex; var incy: Integer; var a: Complex; var lda: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zhemv_(var uplo: AnsiChar; var n: Integer; var alpha: Complex; var a: Complex; var lda: Integer; var x: Complex; var incx: Integer; var beta: Complex; var y: Complex; var incy: Integer; uplo_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zher2_(var uplo: AnsiChar; var n: Integer; var alpha: Complex; var x: Complex; var incx: Integer; var y: Complex; var incy: Integer; var a: Complex; var lda: Integer; uplo_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zher2k_(var uplo: AnsiChar; var trans: AnsiChar; var n: Integer; var k: Integer; var alpha: Complex; var a: Complex; var lda: Integer; var b: Complex; var ldb: Integer; var beta: Double; var c__: Complex; var ldc: Integer; uplo_len: Integer; trans_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zscal_(var n: Integer; var za: Complex; var zx: Complex; var incx: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zswap_(var n: Integer; var zx: Complex; var incx: Integer; var zy: Complex; var incy: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function ztrmm_(var side: AnsiChar; var uplo: AnsiChar; var transa: AnsiChar; var diag: AnsiChar; var m: Integer; var n: Integer; var alpha: Complex; var a: Complex; var lda: Integer; var b: Complex; var ldb: Integer; side_len: Integer; uplo_len: Integer; transa_len: Integer; diag_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dznrm2_(var n: Integer; var x: Complex; var incx: Integer): Double; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};

{ Lapack proper }
function dsytrd_(var uplo: AnsiChar; var n: Integer; var a: Double; var lda: Integer; var d__: Double; var e: Double; var tau: Double; var work: Double; var lwork: Integer; var info: Integer; uplo_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlaebz_(var ijob: Integer; var nitmax: Integer; var n: Integer; var mmax: Integer; var minp: Integer; var nbmin: Integer; var abstol: Double; var reltol: Double; var pivmin: Double; var d__: Double; var e: Double; var e2: Double; var nval: Integer; var ab: Double; var c__: Double; var mout: Integer; var nab: Integer; var work: Double; var iwork: Integer; var info: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.plapack.dll' {$ENDIF};
function dlagtf_(var n: Integer; var a: Double; var lambda: Double; var b: Double; var c__: Double; var tol: Double; var d__: Double; var in__: Integer; var info: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlagts_(var job: Integer; var n: Integer; var a: Double; var b: Double; var c__: Double; var d__: Double; var in__: Integer; var y: Double; var tol: Double; var info: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlamch_(var cmach: AnsiChar; cmach_len: Integer): Double; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
//function dlamc1_(var beta: Integer; var t: Integer; var rnd: LogBool; var ieee1: LogBool): Integer; plapack.dll'l; external;
//function dlamc2_(var beta: Integer; var t: Integer; var rnd: LogBool; var eps: Double; var emin: Integer; var rmin: Double; var emax: Integer; var rmax: Double): Integer; plapack.dll'l; external;
//function dlamc4_(var emin: Integer; var start: Double; var base: Integer): Integer; plapack.dll'l; external;
//function dlamc5_(var beta: Integer; var p: Integer; var emin: Integer; var ieee: LogBool; var emax: Integer; var rmax: Double): Integer; plapack.dll'l; external;
function dlanst_(var norm: AnsiChar; var n: Integer; var d__: Double; var e: Double; norm_len: Integer): Double; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlansy_(var norm: AnsiChar; var uplo: AnsiChar; var n: Integer; var a: Double; var lda: Integer; var work: Double; norm_len: Integer; uplo_len: Integer): Double; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlapy2_(var x: Double; var y: Double): Double; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlar1v_(var n: Integer; var b1: Integer; var bn: Integer; var sigma: Double; var d__: Double; var l: Double; var ld: Double; var lld: Double; var gersch: Double; var z__: Double; var ztz: Double; var mingma: Double; var r__: Integer; var isuppz: Integer; var work: Double): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlarf_(var side: AnsiChar; var m: Integer; var n: Integer; var v: Double; var incv: Integer; var tau: Double; var c__: Double; var ldc: Integer; var work: Double; side_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlarfb_(var side: AnsiChar; var trans: AnsiChar; var direct: AnsiChar; var storev: AnsiChar; var m: Integer; var n: Integer; var k: Integer; var v: Double; var ldv: Integer; var t: Double; var ldt: Integer; var c__: Double; var ldc: Integer; var work: Double; var ldwork: Integer; side_len: Integer; trans_len: Integer; direct_len: Integer; storev_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlarfg_(var n: Integer; var alpha: Double; var x: Double; var incx: Integer; var tau: Double): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlarft_(var direct: AnsiChar; var storev: AnsiChar; var n: Integer; var k: Integer; var v: Double; var ldv: Integer; var tau: Double; var t: Double; var ldt: Integer; direct_len: Integer; storev_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlarnv_(var idist: Integer; var iseed: Integer; var n: Integer; var x: Double): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlarrb_(var n: Integer; var d__: Double; var l: Double; var ld: Double; var lld: Double; var ifirst: Integer; var ilast: Integer; var sigma: Double; var reltol: Double; var w: Double; var wgap: Double; var werr: Double; var work: Double; var iwork: Integer; var info: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlarre_(var n: Integer; var d__: Double; var e: Double; var tol: Double; var nsplit: Integer; var isplit: Integer; var m: Integer; var w: Double; var woff: Double; var gersch: Double; var work: Double; var info: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlarrf_(var n: Integer; var d__: Double; var l: Double; var ld: Double; var lld: Double; var ifirst: Integer; var ilast: Integer; var w: Double; var dplus: Double; var lplus: Double; var work: Double; var iwork: Integer; var info: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlarrv_(var n: Integer; var d__: Double; var l: Double; var isplit: Integer; var m: Integer; var w: Double; var iblock: Integer; var gersch: Double; var tol: Double; var z__: Double; var ldz: Integer; var isuppz: Integer; var work: Double; var iwork: Integer; var info: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlaruv_(var iseed: Integer; var n: Integer; var x: Double): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlascl_(var type__: AnsiChar; var kl: Integer; var ku: Integer; var cfrom: Double; var cto: Double; var m: Integer; var n: Integer; var a: Double; var lda: Integer; var info: Integer; type_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlaset_(var uplo: AnsiChar; var m: Integer; var n: Integer; var alpha: Double; var beta: Double; var a: Double; var lda: Integer; uplo_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlasq2_(var n: Integer; var z__: Double; var info: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlasq5_(var i0: Integer; var n0: Integer; var z__: Double; var pp: Integer; var tau: Double; var dmin__: Double; var dmin1: Double; var dmin2: Double; var dn: Double; var dnm1: Double; var dnm2: Double; var ieee: LogBool): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlasq6_(var i0: Integer; var n0: Integer; var z__: Double; var pp: Integer; var dmin__: Double; var dmin1: Double; var dmin2: Double; var dn: Double; var dnm1: Double; var dnm2: Double): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlasrt_(var id: AnsiChar; var n: Integer; var d__: Double; var info: Integer; id_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlassq_(var n: Integer; var x: Double; var incx: Integer; var scale: Double; var sumsq: Double): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlatrd_(var uplo: AnsiChar; var n: Integer; var nb: Integer; var a: Double; var lda: Integer; var e: Double; var tau: Double; var w: Double; var ldw: Integer; uplo_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dorm2l_(var side: AnsiChar; var trans: AnsiChar; var m: Integer; var n: Integer; var k: Integer; var a: Double; var lda: Integer; var tau: Double; var c__: Double; var ldc: Integer; var work: Double; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dorm2r_(var side: AnsiChar; var trans: AnsiChar; var m: Integer; var n: Integer; var k: Integer; var a: Double; var lda: Integer; var tau: Double; var c__: Double; var ldc: Integer; var work: Double; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dormtr_(var side: AnsiChar; var uplo: AnsiChar; var trans: AnsiChar; var m: Integer; var n: Integer; var a: Double; var lda: Integer; var tau: Double; var c__: Double; var ldc: Integer; var work: Double; var lwork: Integer; var info: Integer; side_len: Integer; uplo_len: Integer; trans_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dstebz_(var range: AnsiChar; var order: AnsiChar; var n: Integer; var vl: Double; var vu: Double; var il: Integer; var iu: Integer; var abstol: Double; var d__: Double; var e: Double; var m: Integer; var nsplit: Integer; var w: Double; var iblock: Integer; var isplit: Integer; var work: Double; var iwork: Integer; var info: Integer; range_len: Integer; order_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dstein_(var n: Integer; var d__: Double; var e: Double; var m: Integer; var w: Double; var iblock: Integer; var isplit: Integer; var z__: Double; var ldz: Integer; var work: Double; var iwork: Integer; var ifail: Integer; var info: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dsterf_(var n: Integer; var d__: Double; var e: Double; var info: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dsyevr_(var jobz: AnsiChar; var range: AnsiChar; var uplo: AnsiChar; var n: Integer; var a: Double; var lda: Integer; var vl: Double; var vu: Double; var il: Integer; var iu: Integer; var abstol: Double; var m: Integer; var w: Double; var z__: Double; var ldz: Integer; var isuppz: Integer; var work: Double; var lwork: Integer; var iwork: Integer; var liwork: Integer; var info: Integer; jobz_len: Integer; range_len: Integer; uplo_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dsytd2_(var uplo: AnsiChar; var n: Integer; var a: Double; var lda: Integer; var d__: Double; var e: Double; var tau: Double; var info: Integer; uplo_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlae2_(var a: Double; var b: Double; var c__: Double; var rt1: Double; var rt2: Double): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function ilaenv_(var ispec: Integer; var name__: AnsiChar; var opts: AnsiChar; var n1: Integer; var n2: Integer; var n3: Integer; var n4: Integer; name_len: Integer; opts_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlartg_(var f, g, cs, sn, r:Double): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dpotrf_(var uplo: AnsiChar; var n: Integer; var a: Double; var lda: Integer; var info: Integer; uplo_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dpotf2_(var uplo: AnsiChar; var n: Integer; var a: Double; var lda: Integer; var info: Integer; uplo_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};


function dgetrf_(var m: Integer; var n: Integer; var a: Double; var lda: Integer; var ipiv: Integer; var info: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dgetf2_(var m: Integer; var n: Integer; var a: Double; var lda: Integer; var ipiv: Integer; var info: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlaswp_(var n: Integer; var a: Double; var lda: Integer; var k1: Integer; var k2: Integer; var ipiv: Integer; var incx: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dtrtri_(var uplo: AnsiChar; var diag: AnsiChar; var n: Integer; var a: Double; var lda: Integer; var info: Integer; uplo_len: Integer; diag_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dtrti2_(var uplo: AnsiChar; var diag: AnsiChar; var n: Integer; var a: Double; var lda: Integer; var info: Integer; uplo_len: Integer; diag_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dgetri_(var n: Integer; var a: Double; var lda: Integer; var ipiv: Integer; var work: Double; var lwork: Integer; var info: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dgetrs_(var trans: AnsiChar; var n: Integer; var nrhs: Integer; var a: Double; var lda: Integer; var ipiv: Integer; var b: Double; var ldb: Integer; var info: Integer; trans_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};


function zheevr_(var jobz: AnsiChar; var range: AnsiChar; var uplo: AnsiChar; var n: Integer; var a: Complex; var lda: Integer; var vl: Double; var vu: Double; var il: Integer; var iu: Integer; var abstol: Double; var m: Integer; var w: Double; var z__: Complex; var ldz: Integer; var isuppz: Integer; var work: Complex; var lwork: Integer; var rwork: Double; var lrwork: Integer; var iwork: Integer; var liwork: Integer; var info: Integer; jobz_len: Integer; range_len: Integer; uplo_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zunmtr_(var side: AnsiChar; var uplo: AnsiChar; var trans: AnsiChar; var m: Integer; var n: Integer; var a: Complex; var lda: Integer; var tau: Complex; var c__: Complex; var ldc: Integer; var work: Complex; var lwork: Integer; var info: Integer; side_len: Integer; uplo_len: Integer; trans_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dladiv_(var a: Double; var b: Double; var c__: Double; var d__: Double; var p: Double; var q: Double): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dlapy3_(var x: Double; var y: Double; var z__: Double): Double; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function ilazlc_(var m: Integer; var n: Integer; var a: Complex; var lda: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zhetd2_(var uplo: AnsiChar; var n: Integer; var a: Complex; var lda: Integer; var d__: Double; var e: Double; var tau: Complex; var info: Integer; uplo_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zhetrd_(var uplo: AnsiChar; var n: Integer; var a: Complex; var lda: Integer; var d__: Double; var e: Double; var tau: Complex; var work: Complex; var lwork: Integer; var info: Integer; uplo_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zlacgv_(var n: Integer; var x: Complex; var incx: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zladiv_(var ret_val: Complex; var x: Complex; var y: Complex): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zlansy_(var norm: AnsiChar; var uplo: AnsiChar; var n: Integer; var a: Complex; var lda: Integer; var work: Double; norm_len: Integer; uplo_len: Integer): Double; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zlar1v_(var n: Integer; var b1: Integer; var bn: Integer; var lambda: Double; var d__: Double; var l: Double; var ld: Double; var lld: Double; var pivmin: Double; var gaptol: Double; var z__: Complex; var wantnc: LogBool; var negcnt: Integer; var ztz: Double; var mingma: Double; var r__: Integer; var isuppz: Integer; var nrminv: Double; var resid: Double; var rqcorr: Double; var work: Double): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zlarf_(var side: AnsiChar; var m: Integer; var n: Integer; var v: Complex; var incv: Integer; var tau: Complex; var c__: Complex; var ldc: Integer; var work: Complex; side_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zlarfb_(var side: AnsiChar; var trans: AnsiChar; var direct: AnsiChar; var storev: AnsiChar; var m: Integer; var n: Integer; var k: Integer; var v: Complex; var ldv: Integer; var t: Complex; var ldt: Integer; var c__: Complex; var ldc: Integer; var work: Complex; var ldwork: Integer; side_len: Integer; trans_len: Integer; direct_len: Integer; storev_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zlarfg_(var n: Integer; var alpha: Complex; var x: Complex; var incx: Integer; var tau: Complex): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zlarrv_(var n: Integer; var vl: Double; var vu: Double; var d__: Double; var l: Double; var pivmin: Double; var isplit: Integer; var m: Integer; var dol: Integer; var dou: Integer; var minrgp: Double; var rtol1: Double; var rtol2: Double; var w: Double; var werr: Double; var wgap: Double; var iblock: Integer; var indexw: Integer; var gers: Double; var z__: Complex; var ldz: Integer; var isuppz: Integer; var work: Double; var iwork: Integer; var info: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zlaset_(var uplo: AnsiChar; var m: Integer; var n: Integer; var alpha: Complex; var beta: Complex; var a: Complex; var lda: Integer; uplo_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zlassq_(var n: Integer; var x: Complex; var incx: Integer; var scale: Double; var sumsq: Double): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zlatrd_(var uplo: AnsiChar; var n: Integer; var nb: Integer; var a: Complex; var lda: Integer; var e: Double; var tau: Complex; var w: Complex; var ldw: Integer; uplo_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zstein_(var n: Integer; var d__: Double; var e: Double; var m: Integer; var w: Double; var iblock: Integer; var isplit: Integer; var z__: Complex; var ldz: Integer; var work: Double; var iwork: Integer; var ifail: Integer; var info: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zstemr_(var jobz: AnsiChar; var range: AnsiChar; var n: Integer; var d__: Double; var e: Double; var vl: Double; var vu: Double; var il: Integer; var iu: Integer; var m: Integer; var w: Double; var z__: Complex; var ldz: Integer; var nzc: Integer; var isuppz: Integer; var tryrac: LogBool; var work: Double; var lwork: Integer; var iwork: Integer; var liwork: Integer; var info: Integer; jobz_len: Integer; range_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zunm2l_(var side: AnsiChar; var trans: AnsiChar; var m: Integer; var n: Integer; var k: Integer; var a: Complex; var lda: Integer; var tau: Complex; var c__: Complex; var ldc: Integer; var work: Complex; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zunm2r_(var side: AnsiChar; var trans: AnsiChar; var m: Integer; var n: Integer; var k: Integer; var a: Complex; var lda: Integer; var tau: Complex; var c__: Complex; var ldc: Integer; var work: Complex; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zlartg_(var f, g: Complex; var cs: Double; var sn, r: Complex): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};

function dgesdd_(var JOBZ: AnsiChar; var M: Integer; var N: Integer; var A: Double {1..LDA,1..*}; var LDA: Integer; var S: Double {1..*};
                 var U: Double {1..LDU,1..*}; var LDU: Integer; var VT: Double {1..LDVT,1..*}; var LDVT: Integer; var WORK: Double {1..*};
                 var LWORK: Integer; var IWORK: Integer; var INFO: Integer; jobz_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};

{ Not thread safe on older compilers, but now all }
function dormql_(var side: AnsiChar; var trans: AnsiChar; var m: Integer; var n: Integer; var k: Integer; var a: Double; var lda: Integer; var tau: Double; var c__: Double; var ldc: Integer; var work: Double; var lwork: Integer; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dormqr_(var side: AnsiChar; var trans: AnsiChar; var m: Integer; var n: Integer; var k: Integer; var a: Double; var lda: Integer; var tau: Double; var c__: Double; var ldc: Integer; var work: Double; var lwork: Integer; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zunmql_(var side: AnsiChar; var trans: AnsiChar; var m: Integer; var n: Integer; var k: Integer; var a: Complex; var lda: Integer; var tau: Complex; var c__: Complex; var ldc: Integer; var work: Complex; var lwork: Integer; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function zunmqr_(var side: AnsiChar; var trans: AnsiChar; var m: Integer; var n: Integer; var k: Integer; var a: Complex; var lda: Integer; var tau: Complex; var c__: Complex; var ldc: Integer; var work: Complex; var lwork: Integer; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};

function dtrtrs_(var uplo, trans, diag: AnsiChar; var n, nrhs: Integer; var a: Double{1..LDA,1..*}; var lda: Integer; var b: Double{1..LDB,1..*}; var ldb, info: Integer; uplo_len, trans_len, diag_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
function dgels_(var TRANS: AnsiChar; var M: Integer; var N: Integer; var NRHS: Integer;
                 var A: Double {1..LDA,1..*}; var LDA: Integer; var B: Double {1..LDB,1..*}; var LDB: Integer;
                 var WORK: Double {1..*}; var LWORK: Integer; var INFO: Integer; trans_len: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};

function dgelsd_(var M: Integer; var N: Integer; var NRHS: Integer;
                 var A: Double {1..LDA,1..*}; var LDA: Integer; var B: Double {1..LDB,1..*}; var LDB: Integer;
                 var S: Double {1..*}; var RCOND: Double; var Rank: Integer;
                 var WORK: Double {1..*}; var LWORK: Integer; var IWORK: Integer; {1..*} var INFO: Integer): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};


{ Re-implemented here }
function ieeeck_(var ispec: Integer; var zero: Single; var one: Single): Integer; cdecl; {$IFDEF EXTDLL} external 'plapack.dll'; {$ENDIF}

{.$DEFINE CHECKIEEE}
{ Original ieeeck routine - only required for checking }
{$IFDEF CHECKIEEE}
function ieeeckfull_(var ispec: Integer; var zero: Single; var one: Single): Integer; cdecl; external {$IFDEF EXTDLL} 'plapack.dll' {$ENDIF};
{$ENDIF}

function xerbla_(SRNAME: PAnsiChar; var Info: Integer; len: FtnLen): Integer; cdecl;

implementation

uses {$IFDEF FPC}{$IFDEF LINUX} initc, {$ENDIF}{$ENDIF}
     f2c, Sysutils, Math;

{$IFDEF FPC}
  {$IFNDEF EXTLAPACK}
    {$IFDEF WIN64}
      {$LINK pblas.o}
      {$LINK plapack.o}
      {$IFDEF CHECKIEEE}
        {$LINK pieeeck.o}
      {$ENDIF}
    {$ELSE}
      {$LINKLIB plapack,STATIC}
      {$LINKLIB pblas,STATIC}
    {$ENDIF}
  {$ENDIF}
{$ELSE}
  {$IFDEF WIN32}
    {$LINK blas.pobj}
    {$LINK lapack.pobj}
  {$ELSE}
    {$IFNDEF EXTDLL}
      {$LINK lapackw64.pobj}
      {$DEFINE NOEXCEPTIONS} // SEH linking broken
    {$ENDIF}
  {$ENDIF}
{$ENDIF}

{$IFDEF FPC}
  {$MACRO ON}
  {$IFDEF DARWIN}
    {$DEFINE alias_:=alias: #95}
  {$ELSE}
    {$IFDEF WIN32}
      {$DEFINE alias_:=alias: #95}
    {$ELSE}
      {$DEFINE alias_:=alias:}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}

procedure ForceMask;
begin
  { Set exception mask as required }
  {$IFNDEF CPUPOWERPC}
    { Comment next line out under Delphi to turn on exceptions }
    {$IFDEF WIN64}
      SetExceptionMask(GetExceptionMask+[exZeroDivide,exOverflow,exInvalidOp]);
    {$ELSE}
      SetExceptionMask(GetExceptionMask+[exZeroDivide,{exOverflow,}exInvalidOp]);
    {$ENDIF}
  {$ELSE}
    asm
      mtfsfi 6,0 // all floating point exceptions disabled - seems to be required for correct LAPACK operation
    end;
  {$ENDIF}
end;

function xerbla_(SRNAME: PAnsiChar; var Info: Integer; len: FtnLen): Integer; cdecl; {$IFDEF FPC} alias_'xerbla_'; {$ENDIF}
{ BLAS error routine }
var
  s: string;
begin
  SetString(s, SRNAME, len);
  {$IFNDEF NOEXCEPTIONS}
  raise Exception.CreateFmt('Error in %s: Parameter %d had an illegal value', [s, Info]);
  {$ENDIF}
end;

{$IFNDEF EXTDLL}
{$DEFINE FORCEMASK}
function ieeeck_(var ispec: Integer; var zero: Single; var one: Single): Integer; cdecl; {$IFDEF FPC} alias_'ieeeck_'; {$ENDIF}
begin
  { Note: LAPACK requires exZeroDivide and exInvalidOp to be masked for best operation }
  {$IFDEF FORCEMASK}
    ForceMask;
    Result := 1;
  {$ELSE}
    { Test if exception mask is set as required }
  if
    {$IFDEF CPUPOWERPC}
      True
    {$ELSE}
     ([exZeroDivide,exInvalidOp] * GetExceptionMask) = [exZeroDivide,exInvalidOp]
    {$ENDIF}
  then
    Result := 1
  else
    Result := 0;
  {$ENDIF}
  {$IFDEF CHECKIEEE}
    {i386-darwin OK i386-linux OK i386-win32 OK powerpc-darwin ? x86_64-linux OK x86_64-win64 OK win32 OK win64 OK}
     Result := ieeeckfull_(ispec, zero, one);
  {$ENDIF}
end;

initialization
  ForceMask;
{$ELSE}
type
  TxerblaHandler = function (SRNAME: PAnsiChar; var Info: Integer; len: Integer):Integer;

function SetXerblaHandler(AxerblaHandler: TxerblaHandler):TxerblaHandler; external 'plapack.dll';

initialization
  ForceMask;
  SetXerblaHandler(xerbla_);
{$ENDIF}

end.




