unit RunTests;

interface

procedure DoTests;

implementation

uses SysUtils, Classes, MathSup;

var f: TMemoryStream;
var NewOut: Text;

function Next3(out v:Integer):Boolean;
var
  b: string[3];
begin
  SetLength(b,3);
  Result := f.Read(b[1],3) = 3;
  if Result then
    V := StrToInt(b);
end;

function NextString: string;
var
  ch: AnsiChar;
begin
  while (f.Read(ch,1) = 1) and (ch = ' ') do
    ;
  Result := ch;
  while (f.Read(ch,1) = 1) and (ch > ' ') do
    Result := Result + ch;
  while (f.Read(ch,1) = 1) and (ch <= ' ') do
    if (ch < ' ') and (f.Read(ch,1) = 1) and (ch < ' ') then
      Exit { Second newline }
    else
      Break;
  f.Seek(-1,soFromCurrent);
end;

function DtosM_C(v:Double; Width, Fixed: Integer; FixedSize:Boolean = false):string;
var
  p: Double;
begin
  Result := DtosM(v, Width, Fixed, FixedSize);
  p := Precision(Result);
  if Abs(StrToFloat(Result)-v) > p*1.5 then
    WriteLn('Prec ', Width:3, Fixed:3, ' ', FixedSize:4, ' ', Result, ' ', FloatToStr(v));
end;

procedure CQ(v:Double; Width, Fixed: Integer);
var
  s: string;
begin
  s := DtosM_C(v, Width, Fixed, False);
  WriteLn(NewOut, Width:3, Fixed:3,  0:3, ' ', s, ' ', FloatToStr(v));
  s := DtosM_C(v, Width, Fixed, True);
  WriteLn(NewOut, Width:3, Fixed:3,-27:3, ' ', s, ' ', FloatToStr(v));
end;

procedure CycleErr(v: Double);
var
  i, n: Integer;
begin
  for i := 0 to 10 do
    for n := -1 to 10 do
      CQ(v,i,n);
end;

procedure DC(v:Double);
var
  i: Integer;
  p: Extended;
begin
  for i := -10 to 10 do begin
    p := IntPower(10,i);
    CycleErr(v*p);
    CycleErr(-v*p);
  end;
end;

procedure DoTests;
var
  w, fix, ww, nOK, nFail: Integer;
  Value: Double;
  Str, NewStr: string;
begin
  AssignFile(NewOut, 'dtos.new');
  Rewrite(NewOut);
  f := TMemoryStream.Create;
  f.LoadFromFile('dtos.out');
  nOK := 0;
  nFail := 0;
  while Next3(w) do begin
    Next3(fix);
    Next3(ww);
    Str := NextString;
    Value := StrToFloat(NextString);
    NewStr := DtosM_C(Value, w, fix, ww=-27);
    if Str <> NewStr then begin
      Inc(nFail);
      WriteLn('Line ', nFail+nOK:7, w:3, fix:3, ' ', Str, ':',Length(Str):2, ' ', NewStr, ':',Length(NewStr):2, ' ', FloatToStr(Value));
    end else
      Inc(nOK);
    CQ(Value, w, Fix);
  end;
  WriteLn(nOK, ' OK ', nFail, ' failed');
  DC(1);
  DC(1.2);
  DC(9.9999999999999999999);
  CloseFile(NewOut);
end;

end.

