unit CntrOptns;
{$I utils.inc}
interface

uses {$IFNDEF CLX_} Graphics, Forms, Controls, StdCtrls, Buttons, ExtCtrls,
     {$ELSE} QGraphics, QForms, QControls, QStdCtrls, QButtons, QExtCtrls, {$ENDIF}
     SysUtils, Classes, NewSpin, Contour, AlEdit, EditExtr;

type

  TContourOptionsDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    LinearButton: TRadioButton;
    CubicSpline: TRadioButton;
    BSpline: TRadioButton;
    Label1: TLabel;
    Points: TSpinBox;
    OrderV: TSpinBox;
    Label2: TLabel;
    GroupBox: TGroupBox;
    ApplyButton: TButton;
    Other: TRadioButton;
    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
  private
    procedure SetContourOptions(const Value: TContourOptions);
    function GetContourOptions: TContourOptions;
  public
    property ContourOptions: TContourOptions read GetContourOptions write SetContourOptions;
  end;

var
  ContourOptionsDlg: TContourOptionsDlg;

implementation

{$IFNDEF LCL_}
{$R *.dfm}
{$ELSE}
{$R *.lfm}
{$ENDIF}

function TContourOptionsDlg.GetContourOptions: TContourOptions;
begin
  with Result do begin
    if LinearButton.Checked then
      CType := ctLinear
    else if CubicSpline.Checked then
      CType := ctCubic
    else  if BSpline.Checked then
      CType := ctBspline
    else
      CType := ctOther;
    nInterp := Points.Value;
    Order := OrderV.Value;
  end;
end;

procedure TContourOptionsDlg.OKBtnClick(Sender: TObject);
begin
  if Assigned(ApplyButton.OnClick) then
    ApplyButton.OnClick(Sender);
  Close;
end;

procedure TContourOptionsDlg.SetContourOptions(const Value: TContourOptions);
begin
  with Value do begin
    case CType of
      ctLinear:  LinearButton.Checked := True;
      ctCubic:   CubicSpline.Checked := True;
      ctBspline: BSpline.Checked := True;
      ctOther:   Other.Checked := True;
    end;
    Points.Value := nInterp;
    OrderV.Value := Order;
  end;
end;

procedure TContourOptionsDlg.CancelBtnClick(Sender: TObject);
begin
  Close;
end;

end.
