unit DPIfix;
{$I utils.inc}{ Copyright (C) 2015 C M Western; see PcontrolsReg.pas for license}
{ Include as first unit to flag program as DPI aware;
  forms must then handle WM_DPICHANGED }
interface

const { High DPI handling }
  PROCESS_DPI_UNAWARE            = 0;
  PROCESS_SYSTEM_DPI_AWARE       = 1;
  PROCESS_PER_MONITOR_DPI_AWARE  = 2;

var
  DPImode: Integer = PROCESS_DPI_UNAWARE;

implementation

uses Windows;

type
  TSetProcessDpiAwareness = function(const ProcessDpiAwareness: LongInt): HRESULT; stdcall;
  TSetProcessDPIAware = function: Boolean;  stdcall;

var
  LIBshcore, LIBuser32: THandle;
  SetProcessDPIAwareness: TSetProcessDpiAwareness;
  SetProcessDPIAware: TSetProcessDPIAware;

initialization
  LIBshcore := LoadLibrary('shcore.dll');
  if LIBshcore <> 0 then begin
    SetProcessDPIAwareness := TSetProcessDPIAwareness(GetProcAddress(LIBshcore, 'SetProcessDpiAwareness'));
    if Assigned(SetProcessDPIAwareness) then begin
      SetProcessDPIAwareness(PROCESS_PER_MONITOR_DPI_AWARE);
      DPImode := PROCESS_PER_MONITOR_DPI_AWARE;
    end;
    FreeLibrary(LIBshcore);
  end;
  if DPImode = PROCESS_DPI_UNAWARE then begin
    LIBuser32 := LoadLibrary('user32.dll');
    if LIBuser32 <> 0 then begin
      SetProcessDPIAware := TSetProcessDPIAware(GetProcAddress(LIBuser32, 'SetProcessDPIAware'));
      if Assigned(SetProcessDPIAware) then begin
        SetProcessDPIAware();
        DPImode := PROCESS_PER_MONITOR_DPI_AWARE;
      end;
      FreeLibrary(LIBuser32);
    end;
  end;
finalization
end.
