unit ResActn;

interface
{$I utils.inc}{ Copyright (C) 2005 C M Western; see PcontrolsReg.pas for license}
uses
  {$IFNDEF CLX_} Controls, ActnList, {$IFDEF VCL_} StdActns, {$ENDIF}
  {$ELSE} QControls, QActnList, QStdActns, {$ENDIF}
  Classes;

type
  TResultAction = class({$IFDEF LCL_}TAction{$ELSE}THintAction{$ENDIF})
  private
    FControl: TControl;
  public
    constructor Create(AOwner: TComponent); override;
    property Control:TControl read FControl write FControl;
    property Hint;
  end;

procedure SetResultForControl(AControl: TControl; const s: string);

implementation

uses {$IFNDEF CLX_} Forms {$ELSE} QForms {$ENDIF} ;

procedure SetResultForControl(AControl: TControl; const s: string);
var
  CControl: TControl;
  ResultAction: TResultAction;
begin
  ResultAction := nil;
  try
    ResultAction := TResultAction.Create(Application);
    ResultAction.Control := AControl;
    ResultAction.Hint := s;
    CControl := AControl;
    while (CControl <> nil) and not CControl.ExecuteAction(ResultAction) do
      CControl := CControl.Parent;
    if CControl = nil then
      ResultAction.Execute;
  finally
    ResultAction.Free;
  end;
end;

{ TResultAction }

constructor TResultAction.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  DisableIfNoHandler := False;
end;


end.
