unit ShowMatGui;
{$I utils.inc}{ Copyright (C) 2010 C M Western; see PcontrolsReg.pas for license}
interface

uses
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, NGrid, Vector, MatrixVec;

type
  TMatForm = class(TForm)
    Matrix: TNumberGrid;
    procedure FormClose(Sender: TObject; var AnAction: TCloseAction);
  end;

var
  MatForm: TMatForm;

procedure ShowMatrix(AMatrix: TMatrix; ACaption: string; cv: TColumnVector);

implementation

{$IFNDEF LCL_}
{$R *.dfm}
{$ELSE}
{$R *.lfm}
{$ENDIF}

uses MathSup, ShowMat;

procedure TMatForm.FormClose(Sender: TObject; var AnAction: TCloseAction);
begin
  AnAction := caFree;
end;

procedure ShowMatrix(AMatrix: TMatrix; ACaption: string; cv: TColumnVector);
var
  MyMatForm: TMatForm;
  i, j: Longint;
begin
  Application.CreateForm(TMatForm, MyMatForm);
  with MyMatForm do begin
    Caption := ACaption;
    with Matrix do begin
      RowCount := AMatrix.RowCount+1;
      ColCount := AMatrix.ColCount+1;
      for i := 1 to ColCount-1 do begin
        Title[i] := IntToStr(i);
        for j := 1 to RowCount-1 do
          Value[j, i] := AMatrix[j, i];
      end;
      if cv <> nil then begin
        for i := 1 to RowCount-1 do
          Lbl[i] := dtosm(cv[i], 10, -1);
      end;
    end;
    Show;
    Matrix.AutoDefaultRowHeight;
  end;
end;

initialization
  ShowMatrixProc := @ShowMatrix;
end.
