unit WidthFrm;
{$I utils.inc}{ Copyright (C) 2015 C M Western; see PcontrolsReg.pas for license}
interface

uses
  SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, AlEdit, EditExtr, NewSpin, Graphs;

type
  TWidthForm = class(TForm)
    WidthLbl: TLabel;
    PenWidth: TFixedSpin;
    OKButton: TButton;
    CancelButton: TButton;
    procedure FormShow(Sender: TObject);
    procedure PenWidthChange(Sender: TObject);
  private
    OriginalWidth: Single;
  public
    LiveGraph: TGraphB;
    WidthChanged: TNotifyEvent;
    procedure UpdateWidth(AWidth: Single);
  end;

function WidthDialog(G: TGraphB; AOnChange: TNotifyEvent): Boolean;

implementation

uses GraphI;

{$IFNDEF FPC}
{$R *.dfm}
{$ELSE}
{$R *.lfm}
{$ENDIF}

function WidthDialog(G: TGraphB; AOnChange: TNotifyEvent): Boolean;
begin
  with TWidthForm.Create(Application) do
    try
      LiveGraph := G;
      WidthChanged := AOnChange;
      Result := ShowModal = mrOK;
      if not Result then
        UpdateWidth(OriginalWidth);
    finally
      Free;
    end;
end;

procedure TWidthForm.FormShow(Sender: TObject);
begin
  if grPensHaveWidth in LiveGraph.GOptions then
    PenWidth.Value := LiveGraph.LineStyles[0].Width
  else
    PenWidth.Value := 0;
  OriginalWidth := PenWidth.Value;
end;

procedure TWidthForm.PenWidthChange(Sender: TObject);
begin
  UpdateWidth(PenWidth.Value);
end;

procedure TWidthForm.UpdateWidth(AWidth: Single);
begin
  if LiveGraph <> nil then begin
    LiveGraph.LineStyles[0].Width := AWidth;
    if AWidth = 0 then
      LiveGraph.GOptions := LiveGraph.GOptions - [grPensHaveWidth]
    else
      LiveGraph.GOptions := LiveGraph.GOptions + [grPensHaveWidth];
    if Assigned(WidthChanged) then
      WidthChanged(Self);
  end;
end;

end.
